*-- Author :    Hartwig Albrecht   05/10/95
*
*-- modified:  Thomas Lohse,  March 13, 1999
*              high pT event weighting or cuts implemented
*              for normal inelastic events
*
      SUBROUTINE ALEVNT

************************************************************************
*
* Description: generate one Lund event
*
* Called from: USEVNT
*
* External references: LUND
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"
#include "auto/MCIN.fi"
#include "auto/MCME.fi"
#include "auto/MEIO.fi"
#include "jets/LUJETS.fi"
#include "pyth/PYSUBS.fi"
#include "pyth/PYPARS.fi"
#include "arte/luopts.fi"

      
      real evwei
      common / weight / evwei

      INTEGER nwi, iwire, crwire
      integer mode1

      INTEGER NI, I
      REAL X, RLU

#include "arte/Arte.ff"
#include "auto/MCIN.ff"
#include "auto/MCME.ff"
#include "auto/MEIO.ff"

C initialize the event weight
      evwei = 1.

C fill Lund particle/decay table

      IF (LUNDINIT .LT. 0)  THEN
        CALL ALTOPP
        CALL ALTDEC
        LUNDINIT = 1
      END IF

C event header bank EVHD

      CALL ATEVHD

C issue warning if event input file is given

      IF (IMEIO_FLAG(LEVI1) .GT. 0 .OR. IMEIO_FLAG(LEVI2) .GT. 0 .OR.
     +    IMEIO_FLAG(LEVI3) .GT. 0 .OR. IMEIO_FLAG(LEVI4) .GT. 0)
     +  CALL MEMESC (7621346, 1, ILARGEST,
     +    'LUND event generator: event input files ignored')

C set seed

      IF (LUNDSEED(1) .EQ. 0 .OR. LUNDSEED(2) .EQ. 0)  CALL ALRINI
      CALL RANECQ (LUNDSEED(1), LUNDSEED(2), 1, 'S')
      X = RLU (1)

C Pythia/Fritiof or Fritiof
      nwi = 1
      IWIRE = CRWIRE(nwi)
      IF (MSEL .EQ. 1)  THEN
        CALL ALFRIT (LUNDRPART)
      ELSE
        CALL ALPYTH
      END IF

C FILL MCME: wire number and material
      IQ(IQMCME_WIRE_L()) = IWIRE   
      CALL CHCTOH(TARGETMAT,IQ(HQMCME_MAT_L()),1)
            
C Number of interactions - Delta or Poisson distribution:

      IF (FIOMIX(2) .EQ. 0.)  GO TO 10
      IF (FIOMIX(2) .LT. 0.)  THEN
        NI = - NINT (FIOMIX(2))
      ELSE
        CALL POISSN (FIOMIX(2), NI, I)
      END IF

      DO I = 1, NI
C Special high-pT modes for FRITIOF switched off for superimposed
C minimum bias events (flag modemb in common /luopts/)
        mode1 = modemb
        modemb = 1
        nwi = nwi+1
        IWIRE = CRWIRE(nwi)
        CALL ALFRIT (0)
        modemb = mode1
C FILL MCME: wire number and material
        IQ(IQMCME_WIRE_L()) = IWIRE   
        CALL CHCTOH(TARGETMAT,IQ(HQMCME_MAT_L()),1)
      END DO

C random seed for GEANT

 10   CALL RANECQ (LUNDSEED(1), LUNDSEED(2), 1, 'R')
      IQ(IQMCIN_RGEA(1,1)) = LUNDSEED(1)
      IQ(IQMCIN_RGEA(2,1)) = LUNDSEED(2)

C save event weight

      Q(QMCME_WGTH(1)) = evwei

      END

************************************************************************
* End of ALEVNT
************************************************************************
