*-- Author :    Hartwig Albrecht   02/02/95
**28.08.99 :modified by Vitali Khachatryan
      SUBROUTINE ATINIT

************************************************************************
*
* Description: Program initialization
*
* Called from: ATMAIN
*
* External references: ...
*
* Arguments: none
*
* Changes:
*
************************************************************************

      IMPLICIT NONE
#include "arte/ArteSelect.fi"
#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"

      INTEGER IZEB(4), DUMMY
      DATA IZEB /4, -2, LLOGF, LSTDO/

#include "arte/Arte.ff"

C general initialization

      CALL UTINIT

C Geant version

      CALL HGVERS

C Zebra initialization

      CALL MZEBRA (IZEB)
      CALL ZPHASE (0)

C Physics generator initialization
      CALL LUINIT
C length of working space declared in user routines:

      CALL USPACE

C initialize MM package

      CALL MMINIT

C Default units

      CALL IOINIT

C Table description

      CALL USAUTT
      IQ(JMEMO+2) = NARLNK
      CALL MMFREE (JMEMO)
      CALL MMFREE (JMEMA)

C establish hierarchy of tables

      CALL MMHIER

C Print title

      CALL LITITL ('TPL')
      IF (HBVERS .EQ. ' ')  CALL MEERRC (897634,
     +  'Arte needs the Unix variable HBVERS which is not given')

C Quasi BLOCK DATA for Lund

cc      CALL ALDATA
cc  Call aldata only if Monte Carlo is ON (V.K.)
      CALL ARTESELECT(I_MONTE_CARLO,I_ALDATA)
C Kuip initialization

      CALL KUINIT (400 000)
      CALL USKUIP
      CALL ATKUIP
      CALL IOKUIP
      CALL MMKUIP
      CALL DBKUIP
      CALL GARTKUIP
      CALL STAGEKUIP
      CALL LIKUIP1
      CALL LIKUIP2
cc      CALL DIKUIP
cc  Call DIKUIP only if DRAW is ON (V.K.)
      CALL ARTESELECT(I_DRAW,I_DIKUIP)
cc      CALL METAKUIP
cc  Call METAKUIP only if DRAW is ON (V.K.)
      CALL ARTESELECT(I_DRAW,I_METAKUIP)
      CALL PARTKUIP
cc      CALL LUNDKUIP
cc  Call LUNDKUIP only if Monte Carlo is ON (V.K.)
      CALL ARTESELECT(I_MONTE_CARLO,I_LUNDKUIP)
cc      CALL HGKUIP
cc  Call HGKUIP only if Monte Carlo is ON (V.K.)
      CALL ARTESELECT(I_MONTE_CARLO,I_HGKUIP)
      CALL DGKUIP
cc      CALL GINTRI
cc  Call GINTRI only if Monte Carlo is ON (V.K.)
      CALL ARTESELECT(I_MONTE_CARLO,I_GINTRI)
      CALL DDKUIP
      CALL USAUTH
      CALL FLKUIP
      CALL GROVERKUIP
      CALL RIREKUIP  
      CALL RISEKUIP
      CALL RITERKUIP
      CALL RCKUIP
      CALL TFKUIP
      CALL L1KUIP
      CALL ACKUIP
      CALL CAREKUIP
      CALL WAXKUIP
      CALL MARPLEKUIP
      CALL GAGEKUIP
c      CALL SUSIKUIP
      CALL ATCALLKUIP
      CALL ITRKUIP

C DbArteBridge initialization

      CALL DBINIT ()

C FARM initialization

      CALL FAINIT ()

C RECO initialization

      CALL RCINIT ()

C Staging

      CALL UTSTIN

C initialize Leda

      CALL LEDAINIT

C read constants

      CALL ATCONS

C Geant initialization - part I

cc      CALL GINIT
cc  Call GINIT only if Monte Carlo is ON (V.K.)
      CALL ARTESELECT(I_MONTE_CARLO,I_GINIT)
cc      CALL HGCONS
cc  Call HGCONS only if Monte Carlo is ON (V.K.)
      CALL ARTESELECT(I_MONTE_CARLO,I_HGCONS)
 
C     init digitization
 
      CALL DGINIT

C check validity of program arguments

      IF (IBATCH .GT. 1)  CALL MEERRC (1783645,
     +  'ATINIT: parameter BATCH or INTERACTIVE not given')

      END

************************************************************************
* End of ATINIT
************************************************************************
