*CMZ :  2.01/01 24/03/95  15.40.43  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   17/03/95

      SUBROUTINE CHWORD (CSTR, CSEP, IS, IB, IE)

************************************************************************
*
* Description: Parse character string CSTR into single words
*              according to the separators stored in CSEP. Multiple
*              blanks and blanks surrounding separators are ignored.
*              Blank space is always a separator; a non-blank separator
*              is a word itself.
*
* Called from: anywhere
*
* External references:
*
* Argument in/out description
*   CSTR   in     character string
*   CSEP   in     separators
*   IS     in     begin search at character IB+1; set to 0 for the
*                 1st word; set IS = IE for the following words.
*   IB     out    begin of word
*   IE     out    end of word : WORD = CSTR(IB:IE)
*                 IE = 0 indicates: no more words
*
************************************************************************

      IMPLICIT NONE

      INTEGER I,IS,IB,IE
      CHARACTER *(*) CSTR,CSEP

      IE = 0
      IB = IS
 10   IF (IB .GE. LEN(CSTR))  GO TO 90
      IB = IB + 1
      IF (CSTR(IB:IB) .EQ. ' ')  GO TO 10
      IE = IB
      DO 20 I = 1, LEN(CSEP)
 20   IF (CSTR(IE:IE) .EQ. CSEP(I:I))  GO TO 90
 30   IF (IE .EQ. LEN(CSTR))  GO TO 90
      IF (CSTR(IE+1:IE+1) .EQ. ' ')  GO TO 90
      DO 40 I = 1, LEN(CSEP)
 40   IF (CSTR(IE+1:IE+1) .EQ. CSEP(I:I))  GO TO 90
      IE = IE + 1
      GO TO 30

 90   END

************************************************************************
* End of CHWORD
************************************************************************
