/* F.Ratnikov: disable everywhere except of SGI (hera-b) */
#ifdef sgi

/* ********************************************************
 *                                                        *
 * FFFFFFFFFFFF   iiiiiiiiii   ll            eeeeeeeeeeee *
 * FFFFFFFFFFFF   iiiiiiiiii   ll            eeeeeeeeeeee *
 * FF                 ii       ll            ee           *
 * FF                 ii       ll            ee           *
 * FF                 ii       ll            ee           *
 * FFFFFFFF           ii       ll            eeeeeeee     *
 * FFFFFFFF           ii       ll            eeeeeeee     *
 * FF                 ii       ll            ee           *
 * FF                 ii       ll            ee           *
 * FF                 ii       ll            ee           *
 * FF             iiiiiiiiii   llllllllllll  eeeeeeeeeeee *
 * FF             iiiiiiiiii   llllllllllll  eeeeeeeeeeee *
 *                                                        *
 *  SSSSSSSSSS    iiiiiiiiii   zzzzzzzzzzzz  eeeeeeeeeeee *
 * SSSSSSSSSSSS   iiiiiiiiii   zzzzzzzzzzzz  eeeeeeeeeeee *
 * SS        SS       ii                zz   ee           *
 * SS                 ii               zz    ee           *
 * SSS                ii              zz     ee           *
 *  SSSSSSSSS         ii             zz      eeeeeeee     *
 *   SSSSSSSSS        ii            zz       eeeeeeee     *
 *          SSS       ii           zz        ee           *
 *           SS       ii          zz         ee           *
 * SS        SS       ii         zz          ee           *
 * SSSSSSSSSSSS   iiiiiiiiii    zzzzzzzzzzz  eeeeeeeeeeee *
 *  SSSSSSSSSS    iiiiiiiiii   zzzzzzzzzzzz  eeeeeeeeeeee *
 *                                                        *
 **********************************************************
 *                                                        *
 *  int filesize_( char *FileName );                      *
 *  int FileSize ( char *FileName );                      *
 *                                                        *
 * Arte call from FORTRAN-77:                             *
 *  SIZE = FILESIZE(NAME(1:LENOCC(NAME)))                 *
 *   (do not forget: INTEGER FILESIZE,EXTERNAL FILESIZE)  *
 *                                                        *
 **********************************************************
 *                                                        *
 * Written by I.Belyaev                                   *
 * Called from: anywhere                                  *
 * Description:                                           *
 *  return the size ( in kBytes) of the file,             *
 *  named "FileName".                                     *
 * Problems with file - returns zero.                     * 
 *                                                        *
 * Uses struct stat and stat function.                    *
 *                                                        *
 **********************************************************
 */

#include <iostream.h>

#include <sys/types.h>
#include <sys/stat.h>

int FileSize( const char *FileName);

extern "C"
{
  int filesize_( const char *Name , const int NameLen)
  { 
    int Len = NameLen ; 
    if( Len <= 0   || Len >= 256 )
      {
	int n1 = strlen(Name); 
	if( n1 <= 0 || n1 >= 256 )
	  {
	    return 0;
	  }
	Len = n1; 
      }
    
    char* NameFile = new char[ Len+1 ];
    strncpy( NameFile , Name , Len );
    NameFile[ Len ] = 0 ; 
    
    return FileSize( NameFile ) ;
  }  
}
/* **************************************************************************
 *                                                                          *
 *    ssssssssss   tttttttttttt   aaaaaaaaaa   rrrrrrrrrrr   tttttttttttt   *
 *   ssssssssssss  tttttttttttt  aaaaaaaaaaaa  rrrrrrrrrrrr  tttttttttttt   *
 *   ss        ss       tt       aa        aa  rr        rr       tt        *
 *   ss                 tt       aa        aa  rr        rr       tt        *
 *   sss                tt       aa        aa  rr        rr       tt        *
 *    sssssssss         tt       aaaaaaaaaaaa  rrrrrrrrrrrr       tt        *
 *     sssssssss        tt       aaaaaaaaaaaa  rrrrrrrrrrr        tt        *
 *            sss       tt       aa        aa  rr    rr           tt        *
 *             ss       tt       aa        aa  rr     rr          tt        *
 *   ss        ss       tt       aa        aa  rr      rr         tt        *
 *   ssssssssssss       tt       aa        aa  rr       rr        tt        *
 *    ssssssssss        tt       aa        aa  rr        rr       tt        *
 *                                                                          *
 ****************************************************************************
 */
int FileSize( const char *FileName)
{  
  struct stat  FileInfo;
  struct stat *fileInfo = &FileInfo;
  
  if( stat( FileName , fileInfo ) )
    {
      return 0;
    }
  if( fileInfo == 0 )
    {
      return 0;
    }
  return FileInfo.st_size/1024;
}
/* **************************************************************************
 *                    end of routine(function) FileSize                     * 
 ****************************************************************************
 *                                                                          *
 *            EEEEEEEEEEEE  NN        NN  DDDDDDDDD                         *
 *            EEEEEEEEEEEE  NNN       NN  DDDDDDDDDD                        *
 *            EE            NNNN      NN  DD       DD                       *
 *            EE            NN NN     NN  DD        DD                      *
 *            EE            NN  NN    NN  DD        DD                      *
 *            EEEEEEEE      NN   NN   NN  DD        DD                      *
 *            EEEEEEEE      NN    NN  NN  DD        DD                      *
 *            EE            NN     NN NN  DD        DD                      *
 *            EE            NN      NNNN  DD        DD                      *
 *            EE            NN       NNN  DD       DD                       *  
 *            EEEEEEEEEEEE  NN        NN  DDDDDDDDDD                        *   
 *            EEEEEEEEEEEE  NN         N  DDDDDDDDD                         *
 *                                                                          *
 ****************************************************************************
 *                    end of routine(function) FileSize                     * 
 ****************************************************************************
 */

#else

/*   everewhere except of SGI  */
extern "C"
{
  int filesize_( const char *Name , const int NameLen )
  { 
    return 0;
  }  
}
#endif

