*-- Author :    Hartwig Albrecht   17/05/95

      SUBROUTINE MMHIER

************************************************************************
*
* Description: Invert the hierarchy relationships between tables
*
* Called from: ATINIT
*
* External references:
*
* Argument in/out description: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEMO.fi"
#include "auto/MEMS.fi"

      INTEGER IL, IS, IR

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/MEMS.ff"

C book temporary table for storing the relation

      CALL MMBWRK (JTEMP, NMEMO(), 2, 10)

C 1st column: pointer within JLINK; 2nd col: next relation

      DO 30 IL = 1, NMEMO()
        IF (HMEMO_NAME(1,IL) .EQ. HBLANKSP)  GO TO 30

        DO 20 IS = 1, 2
          IR = IMEMO_SUP(IS,IL)
          IF (IR .EQ. 0)  GO TO 20

 10       CALL MMBOOK (JTEMP, 1)
          IQ(L_L(1,JTEMP)) = IL
          IQ(L_L(2,JTEMP)) = IQ(L_A(2,IR,JTEMP))
          IQ(L_A(2,IR,JTEMP)) = IQ(JTEMP+2)

          IR = IMEMO_SUP(1,IR)
          IF (IR .NE. 0)  GO TO 10

 20     CONTINUE
 30   CONTINUE

      IF (JMEMS .NE. 0)  CALL MEERRC (76324, 'MMHIER called twice')

C now fill final bank JMEMS.

      DO 70 IL = 1, NMEMO()
        IF (HMEMO_NAME(1,IL) .EQ. HBLANKSP)  GO TO 70

        IQ(IQMEMO_SUB2(IL)) = NMEMS()
        IQ(IQMEMO_SUB1(IL)) = IQ(IQMEMO_SUB2(IL)) + 1

        IR = I_V(2,IL,JTEMP)
 40     IF (IR .EQ. 0)  GO TO 70

        DO 50 IS = IMEMO_SUB1(IL), IMEMO_SUB2(IL)
          IF (IMEMS_SUB(IS) .EQ. I_V(1,IR,JTEMP))  GO TO 60
 50     CONTINUE

        CALL MMBOOK (JMEMS, 1)

        IQ(IQMEMO_SUB2(IL)) = IQ(IQMEMO_SUB2(IL)) + 1
        IQ(IQMEMS_SUB_L()) = I_V(1,IR,JTEMP)

 60     IR = I_V(2,IR,JTEMP)
        GO TO 40

 70   CONTINUE

C now drop temporary bank

      CALL MMBWRK (JTEMP, 0, 1, 0)

      END

************************************************************************
* End of MMHIER
************************************************************************
