*-- Author :    Hartwig Albrecht   02/03/95

      SUBROUTINE UTKUGS (IDEF, IOUT, CPRM, LEN)

************************************************************************
*
* Description: Get character string or positive integer number from KUIP.
*              The string may contain lower case characters
*              (no conversion to upper case).
*
* Called from: KR routines
*
* External references: KUGETx
*
* Argument in/out description
*  IDEF    in     default value for IOUT if no number is given
*  IOUT    out    integer number from KUIP
*  CPRM    out    character string from KUIP; blank if number is given
*  LEN     out    length of CPRM
*
************************************************************************

      IMPLICIT NONE

      INTEGER I, IDEF, IOUT, J, LEN
      CHARACTER CPRM*(*), CDIG(10)
      DATA CDIG /'0','1','2','3','4','5','6','7','8','9'/

      CALL KUGETS (CPRM, LEN)

      IOUT = 0
      IF (LEN .EQ. 0 .OR. LEN .GE. 10)  GO TO 40

      DO 30 I = 1, LEN
        DO 10 J = 0, 9
 10     IF (CPRM(I:I) .EQ. CDIG(J+1))  GO TO 20
        IF (CPRM(I:I) .EQ. ' ')  GO TO 30
        GO TO 40
 20     IOUT = 10 * IOUT + J
 30   CONTINUE
      CPRM = ' '
      LEN = 0
      GO TO 90
 40   IOUT = IDEF
 90   END

************************************************************************
* End of UTKUGS
************************************************************************
