
//                              -*- Mode: C++ -*-
// LkParticle.cc --
//
// $Id: DQ_ClusParticle.C,v 1.1 2000/04/19 20:42:13 natasha Exp $
//
// Copyright (C)  1991  The Board of Trustees of The Leland Stanford
//                                  Junior University.  All Rights Reserved.
//
// Creator         : Tom Pavel  <pavel>     Thu Oct 21 11:28:10 1993
// Modifier        : Tom Pavel  <pavel>     Thu Oct 21 11:28:59 1993
// Update Count    : 1
// Status          : Unknown, Use with caution!
//

#ifdef __GNUG__
#pragma implementation
#endif

#include "dq/DQ_ClusParticle.hh"

// Currently, all functions are inline.  This file serves as a place to put
// the #pragma implementation...
//LkParticle test;


ClusParticle::~ClusParticle() {}

int ClusParticle::isA(ClassId id) {
  return id == ClassID() || LkParticle::isA(id);
}


   // These are for the benefit of Lockable:
//ClusParticle * ClusParticle::child(int i) const
//                     { return dyn_cast(ClusParticle, child(i)); }


void ClusParticle::fill(){
  if( rccl.index()!=0 ){
    xec = rccl->x;
    yec = rccl->y;
    eec = rccl->esum;
    rpidec = rccl->asym;
    nec = (int) (rccl->wid);
    ptec = perp();
    ArteRelationIterator<HITC> relh((rccl->hitc).begin());
    ArtePointer<HITC> hitc(relh);
    gcce = (hitc->gcce).index();
    nfed = ArtePointer<ECHS>(gcce)->fdid;  
    flag = (rccl->flag)/16;
  } else {
    xec = 0.0;
    yec = 0.0;
    eec = 0.0;
    rpidec = 0.0;
    nec = 0;
    ptec = perp();
    gcce = 0;
    nfed = 0;
    flag = 0;
  }
}

void ClusParticle::copy(const ClusParticle & p){
  rccl = p.rccl; 
  xec = p.xec;
  yec = p.yec;  
  eec = p.eec; 
  rpidec = p.rpidec; 
  ptec = p.ptec;
  nec = p.nec; 
  gcce = p.gcce; 
  nfed = p.nfed;
  flag = p.flag;
}


void ClusParticle::dump() const {
  cout<<" Cluster of index "<<rccl.index()<<endl;
  cout<<" Energy: "<<eec<<"   X : "<<xec<<" Y : "<<yec<<endl;

}


