
/********************************
 *
 * Filling of histograms
 *
 ********************************/

/* standard includes */
#include <stdlib.h>
#include <stdio.h>

/* ONLINE includes */
#include "rhp.h"
#include "event.h"

/* Arte includes */
#include "dq/DQ.h"
#include "dq/DQ_ECAL.h"
#include "arte/arte.hh"
#include "care/ECDcalIO.hh"
#include "etb.h"

int
DQ_ECAL_raw_evnt( EVENT_HDR *event )
{

  //  cout<<"DQ_ECAL_raw_evnt"<<endl;

  typedef union{
    short word;
    struct buffer_RO{
      unsigned flt_type     : 3;
      unsigned inhibit_fcs  : 1;
      unsigned test_pulse   : 1;
      unsigned fifo_full_bx : 1;
      unsigned fifo_full_eb : 1;
      unsigned fifo_full_tb : 1;
      unsigned fixed_byte   : 8;
    }record_id;
  }record;

  record rec;
  
  float fint=0.0;

  // Ecal size
  fint =  ArtePointer<DCAL>::nrow();

  ArtePointer<DIHD>dihd(1);
  //  unsigned short firstbx = dihd->bx;
  unsigned short firstbx = 0x8000;

  // Count fed occurrencies
  char occ[256];
  for(int i=0; i<256; ++i) occ[i] = 0;

  unsigned short sfed_id, idmk, bx;
  unsigned short channel, dummy1, dummy2, siz;

  ECDcalIO dcal;
  dcal.start();
  // read the bank header
  dcal.getBankHeader(dummy1, dummy2); 

  unshort fed_id = dcal.nextFED(); // read the Front End Detector IDentifier

  unsigned int tp=0;
  tp = dcal.getFedHeader(siz, sfed_id, idmk, bx);
  unsigned short bx1 = bx;
  fed_id = dcal.nextFED();

  tp = dcal.getFedHeader(siz, sfed_id, idmk, bx);
  unsigned short bx2 = bx;
  fed_id = dcal.nextFED();

  tp = dcal.getFedHeader(siz, sfed_id, idmk, bx);
  unsigned short bx3 = bx;
  fed_id = dcal.nextFED();

  if(bx1 == bx2) firstbx = bx1;
  else if(bx1 == bx3) firstbx = bx1;
  else  firstbx = bx2;

  //  cout<<"BX nuovo  "<<firstbx<<endl;

  dcal.start();
  // read the bank header
  dcal.getBankHeader(dummy1, dummy2); 
  fed_id = dcal.nextFED(); // read the Front End Detector IDentifier

  //  int contt = 0;
  while( fed_id>0 ) {
    // read the header      
    unsigned int nch = dcal.getFedHeader(siz, sfed_id, idmk, bx);

    //    contt++;
    //    if(contt == 1)   cout<<"BX vecchio  "<<firstbx<<endl;

    float ffed_id = (float) sfed_id;
    if( firstbx == 0x8000) firstbx = bx;
    rec.word = idmk;
    
    if(rec.record_id.fifo_full_bx==0) 
      rhp_hf1(DQ_ID(COMP_ECAL,LVL_RAW,22),ffed_id,1);

    if(rec.record_id.fifo_full_eb==0) 
      rhp_hf1(DQ_ID(COMP_ECAL,LVL_RAW,23),ffed_id,1);

    if(rec.record_id.fifo_full_tb==0) 
      rhp_hf1(DQ_ID(COMP_ECAL,LVL_RAW,24),ffed_id,1);

    if(siz != 72) rhp_hf1(DQ_ID(COMP_ECAL,LVL_RAW,25),ffed_id,1);

    rhp_hf1( DQ_ID( COMP_ECAL, LVL_RAW,15),ffed_id , 1 );
    if( fed_id>15 && fed_id<242){
      if( occ[fed_id]==0 ){
	rhp_hf1( DQ_ID( COMP_ECAL, LVL_RAW,16),ffed_id, 1 );
	//	cout<<"firstbx "<<firstbx<<" bx fed "<<bx<<endl;
	if( bx!=firstbx)  rhp_hf1(DQ_ID(COMP_ECAL,LVL_RAW,20),ffed_id,1);
	if((idmk & 0xC000)!=0) rhp_hf1(DQ_ID(COMP_ECAL,LVL_RAW,19),ffed_id,1);
	int err_flg = 0;
	for(unsigned int jj=0; jj<nch; jj++){
          int ofs = 0;
          // readout channel 
          dcal.getNextShort(ofs,channel);
	  //if(channel > 4096)  rhp_hf1(DQ_ID(COMP_ECAL,LVL_RAW,21),ffed_id,1);
	  if(channel > 4096) err_flg = 1; 
	}
	if(err_flg == 1)  rhp_hf1(DQ_ID(COMP_ECAL,LVL_RAW,21),ffed_id,1);

      } else {
	rhp_hf1(DQ_ID(COMP_ECAL,LVL_RAW,17),ffed_id, 1 );
      }
      occ[fed_id]++;
    }
    fed_id = dcal.nextFED(); // go and take the next FED
  }
  //cout<<dec<<endl;
  for(int fed_id=16; fed_id<242; fed_id++)
    if( occ[fed_id]==0 ) 
      rhp_hf1( DQ_ID(COMP_ECAL,LVL_RAW,18),float(fed_id), 1 );
  
  return 0; /* return error code (0 = okay) */
}
