
// ******************************************************************
//
// r spighi january 2000
//
// Declaration of Histograms and Initialization
//
// changes:
// 18 May 2000 (AG) removed ECAL_ihists_initialize() (S. Shuvalov)
//  6 Ju 2000 (AG) polished printout
//
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_ECAL.h"

// prototypes
void ECAL_rec_book( int tcode );

//
// function code
//
int
DQ_ECAL_rec_init()
{
  cout << "DQ_ECAL_rec_init" << endl;
  ECAL_rec_book( 0 );
  ECAL_rec_book( 9 );

  return 0;
}

//
// function code
//
void
ECAL_rec_book( int tcode )
{
  int ad = tcode * 100;

  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1000),"ECAL reco: cluster nr",150,-0.5,149.5);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1001),"ECAL reco: cluster nr ET gt 0.3",150,-0.5,149.5);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1002),"ECAL reco: nr of cell for cluster",13,-0.5,12.5);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1003),"ECAL reco: neutral clusters nr",100,-0.5,99.5);

  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1004),"ECAL reco: charged clusters nr",100,-0.5,99.5);

  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1005),"ECAL reco: charged tracks nr",100,-0.5,99.5);


  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1009+ad),"ECAL reco: Total Energy vs time (100 ev)",200,0,200);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1010+ad),"ECAL reco: Total Energy",200,0.,800.);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1011+ad),"ECAL reco: Total Energy Inner",200,0.,800.);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1012+ad),"ECAL reco: Total Energy Middle",200,0.,800.);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1013+ad),"ECAL reco: Total Energy Outer",200,0.,800.);

  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1015+ad),"ECAL reco: cluster Energy",200,-0.5,199.5);
 rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1016+ad),"ECAL reco: cluster Energy_t",160,0.,4.0);

  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1021),"ECAL reco: Max Energy_T",100,0,10);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1022),"ECAL reco: Second Max Energy_T",100,0,10);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1023),"ECAL reco: Third Max Energy_T",100,0,10);


  rhp_hbook2(DQ_ID(COMP_ECAL,LVL_REC,1101),"ECAL reco: cluster occupancy Inner",70,-78.05,78.05,40,-44.60,44.60);
  rhp_hbook2(DQ_ID(COMP_ECAL,LVL_REC,1102),"ECAL reco: cluster occupancy Middle",80,-223.0,223.0,48,-133.8,133.8);
  rhp_hbook2(DQ_ID(COMP_ECAL,LVL_REC,1103),"ECAL reco: cluster occupancy Outer",56,-312.2,312.2,42,-234.15,234.15);

  rhp_hbook2(DQ_ID(COMP_ECAL,LVL_REC,1111),"ECAL reco: cluster Energy Inner",
	     70,-78.05,78.05,40,-44.60,44.60);
  rhp_hbook2(DQ_ID(COMP_ECAL,LVL_REC,1112),"ECAL reco: cluster Energy Middle",
	     80,-223.0,223.0,48,-133.8,133.8);
  rhp_hbook2(DQ_ID(COMP_ECAL,LVL_REC,1113),"ECAL reco: cluster Energy Outer",
	     56,-312.2,312.2,42,-234.15,234.15);


  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1200),"ECAL reco: Inv Mass pt gt 0.7",300,0,10);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1201),"ECAL reco: Inv Mass pt gt 0.7 Inner",300,0,10);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1202),"ECAL reco: Inv Mass pt gt 0.7 Middle",300,0,10);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1203),"ECAL reco: Inv Mass pt gt 0.7 Outer",300,0,10);

  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1210),"ECAL reco: Pi0 Mass Pt gt 0.3",200,0.05,0.85);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1211),"ECAL reco: Pi0 Mass Inn Pt gt 0.3",200,0.05,0.85);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1212),"ECAL reco: Pi0 Mass Mid Pt gt 0.3",200,0.05,0.85);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1213),"ECAL reco: Pi0 Mass Out Pt gt 0.3 ",200,0.05,0.85);

  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1220),"ECAL reco: Pi0 Mass Pt gt 0.5",200,0.05,0.85);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1221),"ECAL reco: Pi0 Mass Inn Pt gt 0.5",200,0.05,0.85);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1222),"ECAL reco: Pi0 Mass Mid Pt gt 0.5",200,0.05,0.85);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1223),"ECAL reco: Pi0 Mass Out Pt gt 0.5",200,0.05,0.85);

}
