
/******************************************************************* 
 *
 * D. Samtleben 10 Aug 1999
 * A. Gellrich
 *
 * Declaration of Histograms and Initialization
 *
 * hints:
 *        components: COMP_SVD
 *                    COMP_ITR
 *                    COMP_HIPT
 *                    COMP_OTR
 *                    COMP_RICH
 *                    COMP_TRD
 *                    COMP_ECAL
 *                    COMP_MUON
 *                    COMP_FLT
 *                    COMP_SLT
 *                    COMP_TLT
 *                    COMP_FARM
 *
 *         levels:    LVL_RAW
 *                    LVL_HIT
 *                    LVL_REC
 *
 * changes:
 * 22 Oct 1999 (AG) code polishing
 * 27 Oct 1999 (AG) use defines from DQ.h
 *  1 Nov 1999 (AG) get rid of dq_hid.h
 * 19 Nov 1999 (AG) show up
 *
 *******************************************************************/ 

/* standard includes */
#include <stdlib.h>
#include <stdio.h>

/* ONLINE includes */
#include "rhp.h"

/* Arte includes */
#include "dq/DQ.h"
#include "dq/DQ_HIPT.h"

/*               */
/* function code */
/*               */
int
DQ_HIPT_raw_init()
{
  unsigned int histogram_id1 = 1;     /* lowest */
  unsigned int histogram_id2 = 65535; /* highest */

  int   nbinx = 100; /* binning in x */
  int   nbiny = 100; /* binning in y */
  float xmin  = 0;   /* minimal x */
  float xmax  = 100; /* maximal x */
  float ymin  = 0;   /* minimal y */
  float ymax  = 100; /* maximal y */

  printf( "DQ_HIPT_raw_init()\n" );
    
  /* book 1-dim histograms */
  rhp_hbook1( DQ_ID( COMP_HIPT, LVL_RAW, histogram_id1 ),
              "HIPT: This is a test", nbinx, xmin, xmax );

  /* book 2-dim histograms */
  rhp_hbook2( DQ_ID( COMP_HIPT, LVL_RAW, histogram_id2 ),
              "HIPT: This is a test", nbinx, xmin, xmax, nbiny, ymin, ymax );

  return 0; /* return error code (0 = okay) */
}
