// ********************************************************************
//
//  Routine:      gageFitEcalRich
//  Author:       T. Oest
//
//  Description:  VDS/RICH/TARGET match
//
//  Modification:
//
// ********************************************************************

// includes
#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include <algo.h>

#include "arte/arte.hh"

#include "reco/rc99fit98.hh"

//******************************************************************
// function
//******************************************************************
void gageFitOtr(ArtePointer<RSEG> rOTR,
                   float * r0, 
                   float * pTRACK, float * chi2){

    float xOTR, yOTR, zOTR;

const int index[5][5] = { {0, 1,  3, 6,10},
                          {1, 2,  4, 7,11},
                          {3, 4,  5, 8,12},
                          {6, 7,  8, 9,13},
                          {10,11,12,13,14}};
const int index2[5][5] = { {0,1, 2, 3, 4},
                           {1,5, 6, 7, 8},
                           {2,6, 9,10,11},
                           {3,7,10,12,13},
                           {4,8,11,13,14}};
//-----------------------------------------------------------------
//
//-----------------------------------------------------------------
    float pinv, ytarget, xtarget, tyOTR, txOTR;

      xOTR    = rOTR->xf;
      yOTR    = rOTR->yf;
      zOTR    = rOTR->zf;
      tyOTR   = rOTR->tyf;
      txOTR   = rOTR->txf;

      ytarget = yOTR + tyOTR * (0.0 - zOTR);
      xtarget = xOTR + txOTR * (0.0 - zOTR);
      pinv = - xtarget / 280.;     //  1/p



        float zmag = 450.;
        float xmag;
        xmag = xOTR + (zmag - zOTR) * rOTR->txf;

        double pstart[6];
        pstart[0] = r0[2];
        pstart[1] = r0[0];
        pstart[2] = yOTR + (pstart[0] - zOTR) * rOTR->tyf;
        pstart[3] = xmag / zmag;
        pstart[4] = tyOTR;
        pstart[5] = pinv;



       double z, pMeas[5], wMeas[5][5];
        for (int i=0;i<5;i++){for (int j=0;j<5;j++){wMeas[i][j]=0.0;};}


        track_98 track(pstart);

	// VDS x position 

        z        = r0[2];
        pMeas[0] = r0[0];
        pMeas[1] = pstart[2];
        pMeas[2] = pstart[3];
        pMeas[3] = pstart[4];
        pMeas[4] = pstart[5];
        wMeas[0][0] = 10.0;

        track.add_measurement(z, &pMeas[0], &wMeas[0][0]);

	// OTR

        float a;
 

        z        = zOTR;
        pMeas[0] = xOTR;
        pMeas[1] = yOTR;
        pMeas[2] = txOTR;
        pMeas[3] = tyOTR;
        pMeas[4] = pstart[5];
        wMeas[0][0] = 0.1;
        wMeas[1][1] = 0.1;
        wMeas[2][2] = 0.0001;
        wMeas[3][3] = 0.0001;

	/*
        a = rOTR->cvf[0] * rOTR->cvf[2] - 
            rOTR->cvf[1] * rOTR->cvf[1];
        if (a != 0.0){
         wMeas[0][0] =   rOTR->cvf[2] / a;
         wMeas[1][1] =   rOTR->cvf[0] / a;
         wMeas[1][0] = - rOTR->cvf[1] / a;
         wMeas[0][1] = wMeas[1][0];
        } else {
         wMeas[0][0] = 1./rOTR->cvf[0];
         wMeas[1][1] = 1./rOTR->cvf[2];
         wMeas[1][0] = 0.0;
         wMeas[0][1] = 0.0;
        };

        a = rOTR->cvf[5]  * rOTR->cvf[9] - 
            rOTR->cvf[8]  * rOTR->cvf[8];
        if (a != 0.0){
         wMeas[2][2] =   rOTR->cvf[9] / a;
         wMeas[3][3] =   rOTR->cvf[5]  / a;
         wMeas[3][2] = - rOTR->cvf[8]  / a;
         wMeas[2][3] = wMeas[3][2];
        } else {
         wMeas[2][2] = 1./rOTR->cvf[5];
         wMeas[3][3] = 1./rOTR->cvf[9];
         wMeas[3][2] = 0.0;
         wMeas[2][3] = 0.0;
        };
	*/

        track.add_measurement(z, &pMeas[0], &wMeas[0][0]);

	// fit
        *chi2 = float(track.fit());

        double * parameters, * covariance;;
        parameters  = track.track_parameters();
        float p     = 1./fabs(float(parameters[5]));
        covariance  = track.track_errors();

        pTRACK[0]  = float(parameters[0]);
	pTRACK[1]  = float(parameters[1]);
	pTRACK[2]  = float(parameters[2]);
        pTRACK[3]  = float(parameters[3]);
        pTRACK[4]  = float(parameters[4]);
        pTRACK[5]  = float(parameters[5]);

 /*
   cout << "  z    " << pTRACK[0] << endl;
   cout << "  x    " << pTRACK[1] << endl;
   cout << "  y    " << pTRACK[2] << endl;
   cout << "  tx   " << pTRACK[3] << endl;
   cout << "  ty   " << pTRACK[4] << endl;
   cout << "  p    " << pTRACK[5] << endl;
 */

};



