
// ********************************************************************
//
//  Routine:      gageInit
//  Author:       T. Oest
//
//  Description:  initialization of rhp histograms for global alignment
//
//  Modification:
//
// ********************************************************************

#include <iostream.h>
#include "rhp.h"
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "gage/gage.hh"

static int firstCall    = 1;

//*********************************************************************
// function
//*********************************************************************

int gageInit(){

//---------------------------------------------------------------------
//  check if initialization is already done
//---------------------------------------------------------------------

 if (firstCall == 0) return -1;

  firstCall = 1;

//---------------------------------------------------------------------
//  book ring buffer
//---------------------------------------------------------------------

  rbf_book( AC_ID( COMP_CORR, LVL_REC, 1 ), 
            "GAGE: general ring buffer", 
            MaxSegmentPairs, sizeof(GageSegmentPair));


//---------------------------------------------------------------------
//  book histograms for VDS alignment
//---------------------------------------------------------------------

  /*
  rhp_hbook2( AC_ID( COMP_CORR, LVL_REC, 100 ), 
              "GAGE: OTR/VDS: delta x vs delta y", 
               100, -1.0, 1.0, 100, -1.0, 1.0 );

  rhp_hbook2( AC_ID( COMP_CORR, LVL_REC, 101 ), 
              "GAGE: OTR/VDS: delta tan x vs delta tan y", 
               100, -0.01, 0.01, 100, -0.01, 0.01 );

//---------------------------------------------------------------------
//  book histograms for RICH alignment
//---------------------------------------------------------------------

  rhp_hbook2( AC_ID( COMP_CORR, LVL_REC, 110 ), 
              "GAGE: ECAL/RICH: delta tanx vs delta tany", 
               100, -0.01, 0.01, 100, -0.01, 0.01 );

  rhp_hbook2( AC_ID( COMP_CORR, LVL_REC, 111 ), 
              "GAGE: OTR/RICH: delta tanx vs delta tany", 
               100, -0.05, 0.05, 100, -0.05, 0.05 );

//---------------------------------------------------------------------
//  book histograms for ECAL alignment
//---------------------------------------------------------------------

  rhp_hbook2( AC_ID( COMP_CORR, LVL_REC, 120 ), 
              "GAGE: OTR/ECAL: delta x vs delta y", 
               100, -20, 20, 100, -20, 20 );

	       */
//---------------------------------------------------------------------
//  book histograms for VDS alignment
//---------------------------------------------------------------------

  /*
  rhp_hbook1( AC_ID( COMP_CORR, LVL_TST, 21 ), 
              "VDS vs ECAL/RICH: delta x", 50, -1, 1 );
  rhp_hbook1( AC_ID( COMP_CORR, LVL_TST, 22 ), 
              "VDS vs ECAL/RICH: delta y", 50, -1, 1 );
  rhp_hbook1( AC_ID( COMP_CORR, LVL_TST, 23 ), 
              "VDS vs ECAL/RICH: delta tx", 50, -0.01, 0.01 );
  rhp_hbook1( AC_ID( COMP_CORR, LVL_TST, 24 ), 
              "VDS vs ECAL/RICH: delta ty", 50, -0.01, 0.01 );
  */

//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
  return 0;
}
