#include <stdio.h>
#include <string.h>
#include <vector.h>
#include "arte/arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteIOlun.h"
#include "arte/ZQUEST.h"
#include "arte/ArteMessage.hh"
#include "gean/zgmed.hh"

extern "C" {
   void crgean_(char *,int );
   void ioconc_(int *, char *, char *, int *, int, int);
   void iofind_(char *,int *,int);
   void ioopen_(int *,char *,int *,int *,int);
   void ioclos_(int *);
   void cfopen_(int*, int *,int *,char *,int *,char *,int *);
   void gopen_(int *,char *,int *, int *,int);
   void gfout_(int *, char *,int *,int *,char *,int *,int , int);
   void gfin_( int *, char *,int *,int *,char *,int *,int , int);
   void ggclos_();
   void crzgmoth_();
   void gclose_(int*, int*); 
   void rgnini_();
   void mustout_();
   void mustin_();
}
   void gvers();
   void geostat();
   void medmain(int &);
   void fldgeo(int &);
  
void crgean_(char *status,int) {
   int ier=0,  lun=18,  i0=0,  i1=1, istat=3, i1024=1024;    
   int igeom = int(10000.*arteflag_.geomvers+.1);   
   iofind_("GEANBK",&lun,6);
   ArtePointer<MEIO> mio(lun);

   if(!strncmp(status,"PUT",3)) {
      ioopen_(&lun,"LO",&i0,&ier,2);
      if(ier) {
         arteMsg << "ioopen fails" ; arteMsg.error(); 
      }
      quest_.iquest[0] = mio->cfopen;
      gopen_(&lun,"LO",&i1024,&ier,2);       
      if(ier) {
         arteMsg << "gopen fails " ; arteMsg.error(); 
      }
      gfout_(&lun,"INIT",&i1,&igeom," ",&ier,4,1);
      if(ier == 0 || ier >= 7) {}
      else if(ier < 0) {
        arteMsg << "gfout fails " << ier; arteMsg.warn();
      }
      else { 
	arteMsg << "gfout not completely written out " << ier;
	arteMsg.warn();
      }
      mustout_();
   }

   else if(!strncmp(status,"GET",3)) {
      gvers();
      char fname[128];
//    get input file GEANBK
      if(mio->flag < 1 ) {
       strcpy(fname,getenv("HBROOT"));
       strcat(fname,"/GEO/GEAN/gean");
       char txt[7];  sprintf(txt,"%06d",igeom);
       strcat(fname,txt); 
       strcat(fname,".out");
       ioconc_(&lun,fname,"LI",&i0,strlen(fname),2);
     } 

      ioopen_(&lun,"LI",&i0,&ier,2);
      if(ier) {
	arteMsg << "ioopen fails " << ier;  arteMsg.error(); 
      }
      quest_.iquest[0] = mio->cfopen;
      gopen_(&lun,"LI",&i1024,&ier,2);      
      if(ier) {
	arteMsg << "gopen fails " << ier;  arteMsg.error(); 
      }
      gfin_(&lun,"INIT",&i1,&igeom," ",&ier,4,1);
      if(ier == 0 || ier >= 7) {}
      else if(ier < 0) {
	arteMsg << "gfin fails" << ier; arteMsg.error();
      }
      else { 
	arteMsg << "gfin not completely read in " << ier;
	arteMsg.warn();
      }

      crzgmoth_();
      medmain(istat);
      zgmed ZGMED;
      ZGMED.Fill_hg_tmed();  
      fldgeo(istat);
      rgnini_();
      mustin_();     
      ggclos_();
      geostat();
   }
      
   ioclos_(&lun); 
}
