        logical function otrcomc(command,cpar,npar)
************************************************************************
*
* Returns True if command is matched with buffer, False otherwise.
* In this case parameters are copied to array cpar.
*
* Called from: otrgeo otrmod
*
* External references: words word lenocc
*
*
* Arguments  in/out       Description
* =========  ======       ===========
* command    in           command to match
* cpar       out          parameter array to fill
* npar       in (out)     No. of parameters to search for
*                         (negative = use what is supplied in text file,
*                          but check that actual parameters do not
*                          exceed abs(npar)).
*                         Fill with spaces the rest parameters up to abs(npar)
*
* Author: Alexander Lanyov     Feb 1997
* Updated Aug 1999
************************************************************************
        implicit none

#include "arte/Arte.fi"
#include "gean/otrgeo.fi"

        character*(*) command,cpar(maxpar)
        character*121 command1

        character*80 word,buf2
        integer npar,l,i,j

        integer npar1
        common /cotrcom/ npar1

        integer lenocc,words
#include "arte/Arte.ff"

        ierror = 0
        otrcomc=.false.
        l=len(command)
        if (len(buf).le.l) return
        command1 = command//' '

c        write (*,*) 'OTRCOMC:      buf="',buf(:l+1),'"'
c        write (*,*) 'OTRCOMC: command1="',command1(:l),'"'

        if (buf(:l+1) .ne. command1(:l)) return

        buf2=buf(l+1:)
c       write (*,*) 'buf2="',buf2,'"'
c       write (*,*) 'words=',words(buf2)
        npar1=npar
        if (npar1.lt.0) then
           i=words(buf2)
           if (i .gt. abs(npar1)) then
              c78='Wrong number of parameters'
              call ch78bi(words(buf(l+1:)))
              call ch78ac(', but should not exceed')
              call ch78bi(abs(npar1))
              call meerro(c78)
           end if
           npar1=i
        else
           i=words(buf2)
           if (i .gt. abs(npar1)) then
              c78='Wrong number of parameters'
              call ch78bi(words(buf(l+1:)))
              call ch78ac(', but should not exceed')
              call ch78bi(abs(npar1))
              call meerro(c78)
           end if
           npar1=i
        end if

        if (npar1.gt.maxpar) then
           c78='Number of parameters'
           call ch78bi(npar1)
           call ch78ac(' should be not greater than')
           call ch78bi(maxpar)
           call meerro(c78)
        end if

        do i=1,npar1
           cpar(i)=word(buf2,i)
           lpar(i)=lenocc(cpar(i))
           if (cpar(i)(1:1) .eq. '-' .and. lpar(i).eq.1) then
              cpar(i) = '0'
           else
              do j=1,lpar(i)
                 if (cpar(i)(j:j) .eq. ',') cpar(i)(j:j) = '.'
              end do
           end if
        end do

        do i=npar1+1,abs(npar)
           cpar(i)=' '
           lpar(i)=0
        end do

        otrcomc=.true.
        return
        end
c=======================================================================
        logical function otrcomi(command,ipar,npar)
************************************************************************
* The same as OTRCOMC, but reads integer parameters instead of character ones.
*
* Arguments  in/out       Description
* =========  ======       ===========
* command    in           command to match
* ipar       out          parameter array to fill
* npar       in (out)     No. of parameters to search for
*                         (-1 = use what is supplied in text file)
*
* Author: Alexander Lanyov     Feb 1997
************************************************************************
        implicit none
#include "arte/Arte.fi"
#include "gean/otrgeo.fi"

        character*(*) command
        integer npar,i
        integer ipar(maxpar)
        logical otrcomc

        integer npar1
        common /cotrcom/ npar1

        integer lenocc
#include "arte/Arte.ff"

        otrcomi=.false.
        if (.not.otrcomc(command,cparam,npar)) return

        do i=1,npar1
           read (cparam(i),*,err=99) ipar(i)
        end do

        do i=npar1+1,abs(npar)
           ipar(i) = 0
        end do

        otrcomi=.true.
        return

99      continue

        c78 = ' ? Error reading parameter No.'
        call ch78ai(i)
        call ch78ac(' "')
        call ch78ac(cparam(i)(:lenocc(cparam(i))))
        call ch78ac('" at command "')
        call ch78ac(command(:lenocc(command)))
        call meerro (c78)

        ierror = -i
	call atstop('Error reading parameter')
        return          ! Should we stop the program here??

        end
c=======================================================================
        logical function otrcomr(command,par,npar)
************************************************************************
* The same as OTRCOMC, but reads real parameters instead of character ones.
*
* Bugs: reading '4.57s5' from internal buffer, Fortran gives '4.57' !!!
*
* Arguments  in/out       Description
* =========  ======       ===========
* command    in           command to match
* par        out          parameter array to fill
* npar       in (out)     No. of parameters to search for
*                         (-1 = use what is supplied in text file)
*
* Author: Alexander Lanyov     Feb 1997
************************************************************************
        implicit none
#include "arte/Arte.fi"
#include "gean/otrgeo.fi"

        character*(*) command
        integer npar,i
        real par(maxpar)
        logical otrcomc

        integer npar1
        common /cotrcom/ npar1

        integer lenocc
#include "arte/Arte.ff"

        otrcomr=.false.
        if (.not.otrcomc(command,cparam,npar)) return

        do i=1,npar1
           read (cparam(i),*,err=99) par(i)
        end do

        do i=npar1+1,abs(npar)
           par(i) = 0.
        end do

        otrcomr=.true.
        return

99      continue

        c78 = ' ? Error reading parameter No.'
        call ch78ai(i)
        call ch78ac(' "')
        call ch78ac(cparam(i)(:lenocc(cparam(i))))
        call ch78ac('" at command "')
        call ch78ac(command(:lenocc(command)))
        call meerro (c78)

        ierror = -i
	call atstop('Error reading parameter')
        return          ! Should we stop the program here??

        end
c=======================================================================
        integer function iread(str)
************************************************************************
*
* Returns integer number from a string.
*
* Called from: otrgeo otrmod
*
* External references: lenocc
*
*
* Arguments  in/out       Description
* =========  ======       ===========
* str        in           string to read
*
* Author: Alexander Lanyov     May 1997
************************************************************************
        implicit none
#include "arte/Arte.fi"

        character*(*) str
        integer l

        integer lenocc
#include "arte/Arte.ff"

        l = lenocc(str)
        if (l.le.0 .or. str(:l).eq.'-') then
           iread = 0
        else
           read (str(:l),*,err=999) iread
        end if
        return

999     continue
        c78 = ' ? Error reading integer parameter "'
        call ch78ac(str(:l))
        call ch78ac('"')
        call meerro (c78)
        iread = 0
        return
        end
c=======================================================================
        subroutine parse(buf,nwords,words,lw,nlast)
*
* No longer used!! (instead CERNLIB is used)
*
************************************************************************
* Parses a string to an word array.
*
* External references:
*
* Arguments  in/out       Description
* =========  ======       ===========
* buf        in/out       string to parse
*                         (conversion to lower case is made,
*                          tabs are changed to spaces)
* nwords     out          No. of words
* words      out          word array
* lw         out          words' length !1'
* nlast      out          last non-blank character in string
*
* Author: Alexander Lanyov     Feb 1997
************************************************************************
        implicit none
        integer maxwor
        parameter (maxwor=20)

        character*(*) buf,words(maxwor)
        integer i,ic,nlast,nwords,lw(maxwor)
        character*120 bu

        nlast=0
        do i=1,len(buf)
           ic=ichar(buf(i:i))
           if (ic.ge.ichar('A') .and. ic.le.ichar('Z'))
     @        buf(i:i)=char(ic+ichar('a')-ichar('A'))
           if (ic.eq.9) buf(i:i)=' '
           if (buf(i:i).ne.' ') nlast=i
        end do

        bu=buf
        nwords=0
        do while (bu.ne.' ')
           do while (bu(1:1).eq.' ')
              bu=bu(2:)
           end do
           i=index(bu,' ')
           if (nwords.ge.maxwor) return
           nwords=nwords+1
           words(nwords)=bu(:i-1)
           lw(nwords)=i-1
           bu=bu(i:)
c          write (*,*) 'words(',nwords,')="',
c     @                 words(nwords)(:lw(nwords)),'"'
        end do

        do i=nwords+1,maxwor
           words(i)=' '
        end do

        return
        end
