
*-- Author : Vik Egorytchev, 07/09/96  17.37.13
C----------------------------------------------------------
        SUBROUTINE T R D E P H (E0)
        IMPLICIT NONE
C
C... *** Simulate res within straw in case photon absorb ***
C
C...Kinematics of generated secondaries
C
#include "gean/gcking.fi"
#include "gean/gckine.fi"
#include "gean/gctrak.fi"
C...
        REAL RNDM(3), E0, EF, E2, PM, PL, PK
C...
        EF     = E0*1.E6
        CALL FRA(EF,PM,PL,PK)
        CALL GRNDM(RNDM,3)
C...
        IF(RNDM(1).LT.PM) RETURN
        IF(RNDM(1).GT.(PM+PL)) GO TO 1
        IF(RNDM(2).GT..11) RETURN              ! L-level
        E0     = (EF-4.2)*1.E-6
        E2     = 4.2E-6
        GO TO 2
1       IF(RNDM(3).GT..88) RETURN              ! K-level
        E0     = (EF-30.)*1.E-6
        E2     = 30.E-6
C
C... Simulation new photon
C
2       NGKINE   = NGKINE+1
        CALL ISOTR(GKIN(1,NGKINE))
        GKIN(1,NGKINE) = GKIN(1,NGKINE)*E2
        GKIN(2,NGKINE) = GKIN(2,NGKINE)*E2
        GKIN(3,NGKINE) = GKIN(3,NGKINE)*E2
        GKIN(4,NGKINE) = E2
        GKIN(5,NGKINE) = 48.
        TOFD  (NGKINE) = 0.
        IFLGK (NGKINE) = 0.
        CALL GSKING(NGKINE)
        NGKINE         = NGKINE-1
C...
        RETURN
        E N D

*-- Author : Valeri Saveliev, 27/03/94  12.17.14
C---------------------------------------------------------
        SUBROUTINE F R A (E,PM,PL,PK)
        IMPLICIT NONE
        REAL E,PM,PL,PK
C
C... *** Calculate fraction different mode of interaction
C        photons with K,L,M-electron shell of XE
C        PM,PL,PK - probability to interact with M,L,K-shells ***
C
        PM      = 0.
        PL      = 0.
        PK      = 0.
C
C...real photon
C
        IF(E.LT.34.56) GO TO 1
        PK      = .83
        PL      = .145
        PM      = .025
        RETURN
C...
1       IF(E.LT.4.8) GO TO 2
        PL      = .84
        PM      = .16
        RETURN
C...
2       IF(E.LT..6) RETURN
        PM      = 1.
        RETURN
        E N D

*-- Author : Valeri Saveliev,27/03/94  12.17.14 
C------------------------------------------------------
        SUBROUTINE I S O T R (P)
        IMPLICIT NONE
C
C... *** Simulation isotropic direction ***
C
        INTEGER K
        REAL P(3),RNDM(3),SP,SQSP
C...
1       CALL GRNDM(RNDM,3)
        DO 2 K = 1,3
        P(K)   = RNDM(K)-.5
2         CONTINUE
C...
        SP     = P(1)**2+P(2)**2+P(3)**2
        IF(SP.GT..25) GO TO 1
        SQSP   = SQRT(SP)
        DO 3 K = 1,3
        P(K)   = P(K)/SQSP
3         CONTINUE
        RETURN
        E N D
