#include "arte/arte.hh"
#include "grover/grover.hh"

//
// Part of the Grover package
// Please see the header file grover.hh
// for authors etc.
//
//
// Modifications:
// When?     Who?     What?
// YY-MM-DD  Name     Modification
// -----------------------------------------------------------------------------
//
//

int GroverFillFromMVER(GroverVertexList* list, int type = 1)
{
  // Fill a list of vertices from MVER according to type flag (default 1 =
  // primary vertices). NB: Internal particle list is filled with initial 
  // decay products, not long-lived daughters. This should be changed
  // in future! 
  //
  // M.Sang 27/05/00

  if (ArteTable<MCIN>::booked()) {
    for (ArteTable<MVER>::iterator imver = ArteTable<MVER>::begin();
	 imver != ArteTable<MVER>::end(); ++imver) {
      if (imver->flag == type) {
	switch (type) {
	case 1: {
	  GroverVertex vtx(imver);
	  list->push_back(vtx);
	  break;
	}
	case 2: {
	  break;
	}
	default: {
	  break;
	}
	}
      }
    }
  }
  return (list->empty()) ? -1 : 0;
}
