>NAME GROVERKUIP

*
*
* Part of the Grover package
* Please see the header file grover.hh
* for authors etc.
*
*
* Modifications:
* When?     Who?     What?
* YY-MM-DD  Name     Modification
* -----------------------------------------------------------------------------
* 00-11-08  M.Sang   Added a few more commands for steering etc.
*
*
*


>MENU /GROVER
>Guidance
Commands related to the Grover vertexing package




>MENU /GROVER/GRAPHICS
>Guidance
Commands related to the 2-D (HIGZ) and 3-D (ROOT) event displays




>MENU /GROVER/GRAPHICS/2D
>Guidance
2D (HIGZ) specific commands

>Command ENABLE
>Guidance
Turn HIGZ 2D event display on/off
>Action KGG2ENABLE
>Parameter
+
NUM '1 = on, 0 = off' I  D='0'




>MENU /GROVER/GRAPHICS/3D
>Guidance
3D (ROOT) specific commands

>Command ENABLE
>Guidance
Turn ROOT 3D event display on/off
>Action KGG3ENABLE
>Parameter
+
NUM '1 = on, 0 = off' I  D='0'

>Command X3D
>Guidance
Toggles X3D display.
>Action KGG3X3D
>Parameter
+
NUM '1 = on, 0 = off' I  D='0'

>Command EXECUTE
>Guidance
Draw the global lists (see manual) with the current options - DISABLED! see manual
>Action KGG3EXEC




>MENU /GROVER/GRAPHICS/3D/VISIBILITY
>Guidance
Set the visibility of the objects (tracks, wires etc.)

>Command BOX
>Guidance
Toggles drawing of box around target region
>Action KGG3VBOX
>Parameter
+
NUM '1 = on, 0 = off' I  D='0'

>Command AXES
>Guidance
Toggles drawing of axes
>Action KGG3VAXES
>Parameter
+
NUM '1 = on, 0 = off' I  D='0'

>Command WIRES
>Guidance
Toggles drawing of target wires
>Action KGG3VWIRES
>Parameter
+
NUM '1 = on, 0 = off' I  D='1'

>Command PRIMARIES
>Guidance
Toggles drawing of primary vertices
>Action KGG3VPRIMARIES
>Parameter
+
NUM '1 = on, 0 = off' I  D='1'

>Command SECONDARIES
>Guidance
Toggles drawing of secondary vertices
>Action KGG3VSECONDARIES
>Parameter
+
NUM '1 = on, 0 = off' I  D='1'

>Command MCPRIMARIES
>Guidance
Toggles drawing of MC primary vertices
>Action KGG3VMCPRIMARIES
>Parameter
+
NUM '1 = on, 0 = off' I  D='1'

>Command MCSECONDARIES
>Guidance
Toggles drawing of MC secondary vertices
>Action KGG3VMCSECONDARIES
>Parameter
+
NUM '1 = on, 0 = off' I  D='1'

>Command PRIMTRACKS
>Guidance
Toggles drawing of tracks in primary vertices
>Action KGG3VPRIMTRACKS
>Parameter
+
NUM '1 = on, 0 = off' I  D='0'

>Command SECTRACKS
>Guidance
Toggles drawing of tracks in secondary vertices
>Action KGG3VSECTRACKS
>Parameter
+
NUM '1 = on, 0 = off' I  D='0'

>Command UNUSEDTRACKS
>Guidance
Toggles drawing of unused tracks
>Action KGG3VUNUSEDTRACKS
>Parameter
+
NUM '1 = on, 0 = off' I  D='0'

>Command SPECIALTRACKS
>Guidance
Toggles drawing of user-defined tracks
>Action KGG3VSPECIALTRACKS
>Parameter
+
NUM '1 = on, 0 = off' I  D='1'




>MENU /GROVER/GRAPHICS/3D/COLOUR
>Guidance
Set the colours of the objects

>Command WIRES
>Guidance 
Colour to draw target wires
>Action KGG3CWIRES
>Parameter
+
NUM 'See ROOT manual for colours' I  D='5'

>Command PRIMARIES
>Guidance
Colour to draw primary vertices
>Action KGG3CPRIMARIES
>Parameter
+
NUM 'See ROOT manual for colours' I  D='0'

>Command SECONDARIES
>Guidance
Colour to draw secondary vertices
>Action KGG3CSECONDARIES
>Parameter
+
NUM 'See ROOT manual for colours' I  D='0'

>Command MCPRIMARIES
>Guidance
Colour to draw MC primary vertices
>Action KGG3CMCPRIMARIES
>Parameter
+
NUM 'See ROOT manual for colours' I  D='0'

>Command MCSECONDARIES
>Guidance
Colour to draw MC secondary vertices
>Action KGG3CMCSECONDARIES
>Parameter
+
NUM 'See ROOT manual for colours' I  D='0'

>Command PRIMTRACKS
>Guidance
Colour to draw tracks in primary vertices
>Action KGG3CPRIMTRACKS
>Parameter
+
NUM 'See ROOT manual for colours' I  D='0'

>Command SECTRACKS
>Guidance
Colour to draw tracks in secondary vertices
>Action KGG3CSECTRACKS
>Parameter
+
NUM 'See ROOT manual for colours' I  D='0'

>Command SPECIALTRACKS
>Guidance
Colour to draw special (user-defined) tracks
>Action KGG3CSPECIALTRACKS
>Parameter
+
NUM 'See ROOT manual for colours' I  D='0'

>Command UNUSEDTRACKS
>Guidance
Colour to draw tracks which were not used in vertices
>Action KGG3CUNUSEDTRACKS
>Parameter
+
NUM 'See ROOT manual for colours' I  D='0'




>MENU /GROVER/GRAPHICS/3D/DIMENSION
>Guidance
Set track lengths to be shown, axis lengths, etc.

>Command PRIMTRACKS
>Guidance
Set drawn length of tracks in primary vertices
>Action KGG3DPRIMTRACKS
>Parameter
+
NUM 'length in cm' R  D='0.5'

>Command SECTRACKS
>Guidance
Set drawn length of tracks in secondary vertices
>Action KGG3DSECTRACKS
>Parameter
+
NUM 'length in cm' R  D='0.5'

>Command SPECIALTRACKS
>Guidance
Set drawn length of special (user-defined) tracks
>Action KGG3DSPECIALTRACKS
>Parameter
+
NUM 'length in cm' R  D='5.0'

>Command UNUSEDTRACKS
>Guidance
Set drawn length of tracks which were not used in vertices
>Action KGG3DUNUSEDTRACKS
>Parameter
+
NUM 'length in cm' R  D='0.5'




>MENU /GROVER/GRAPHICS/3D/QUALITY
>Guidance
Set quality cuts on tracks or vertices to be drawn

>Command PMIN
>Guidance
Set minimum momentum of drawn tracks
>Action KGG3DPMIN
>Parameter
+
NUM 'minimum in GeV' R  D='0.0'

>Command PTMIN
>Guidance
Set minimum transverse momentum of drawn tracks
>Action KGG3DPTMIN
>Parameter
+
NUM 'minimum in GeV' R  D='0.0'

>Command CHI2MAX
>Guidance
Set maximum chi2 of drawn tracks
>Action KGG3DCHI2MAX
>Parameter
+
NUM 'maximum' R  D='1e6'

>Command MINHITS
>Guidance
Set minimum number of VDS hits in drawn tracks
>Action KGG3DMINHITS
>Parameter
+
NUM 'minimum' I  D='0'



>MENU /GROVER/STEERING
>Guidance
Use these commands in the kumac to change default behaviour of GroverEvent()

>Command TSELECTION
>Guidance
Set track selection (see manual)
>Action KGSTSELECTION
>Parameter
+
NUM '1 = default, 2 = RSEGs, 3 = RTRAs, 4 = ...' I  D='1'

>Command FIND_PRIMARIES
>Guidance
Switch on primary vertex finding (see manual)
>Action KGSFINDPRIMARIES
>Parameter
+
NUM '1 = on, 0 = off' I  D='1'

>Command WRITE_RTAR
>Guidance
Switch on the writing of the RTAR table (reconstructed target positions
from primary vertexing) - mainly for use online.
>Action KGSWRITERTAR
>Parameter
+
NUM '1 = on, 0 = off' I  D='0'

>Command WRITE_RVER
>Guidance
Toggle the over-writing of the RVER table (e.g. switch off if finding 
primary vertices many times in the same event)
>Action KGSWRITERVER
>Parameter
+
NUM '1 = on, 0 = off' I  D='1'

>COMMAND FIND_SECONDARIES
>Guidance
Switch on general secondary vertex search (see manual)
>Action KGSFINDSECONDARIES
>Parameter
+
NUM '1 = on, 0 = off' I  D='0'

>COMMAND FIND_JPSIPLUSX
>Guidance
Switch on J/psi+X search (see manual)
>Action KGSFINDJPSIPLUSX
>Parameter
+
NUM '1 = on, 0 = off' I  D='0'

>COMMAND WIREFOLLOWING
>Guidance
Switch on wire-following mechanism in primary finder (see manual)
>Action KGSWIREFOLLOWING
>Parameter
+
NUM '1 = on, 0 = off' I  D='1'

>COMMAND REFITRSEG
>Guidance
Refit all VDS segments using MC momentum (see manual)
>Action KGSREFITRSEG
>Parameter
+
NUM '1 = on, 0 = off' I  D='0'

>COMMAND VERBOSE
>Guidance
Switch on printing of lots of more or less useful messages
>Action KGSVERBOSE
>Parameter
+
NUM '1 = on, 0 = off' I  D='0'

>COMMAND WHBOOK
>Guidance
Book and fill default histograms in HBOOK file
>Action KGSWHBOOK
>Parameter
+
NUM '1 = on, 0 = off' I  D='0'

>COMMAND WROOT
>Guidance
Book and fill default histograms in ROOT file
>Action KGSWROOT
>Parameter
+
NUM '1 = on, 0 = off' I  D='0'

>COMMAND SHOWCUTS
>Guidance
Shows current state of the ggCuts global object
>Action KGSSHOWCUTS




>MENU /GROVER/CUTS
>Guidance
Set various parameters for the individual algorithms




>MENU /GROVER/CUTS/PRIMARIES
>Guidance
Set parameters for the primary vertex finder (experts only)

>COMMAND NHITMIN
>Guidance
Set minimum number of hits in VDS for track to be used
>Action KGCPNHITMIN
>Parameter
+
NUM ' ' I  D='5'

>COMMAND NTRKMIN
>Guidance
Set minimum number of tracks in a vertex
>Action KGCPNTRKMIN
>Parameter
+
NUM ' ' I  D='3'

>COMMAND OVERLAP
>Guidance
Set minimum overlap of tracks with wires or each other (in sigma)
>Action KGCPOVERLAP
>Parameter
+
NUM ' ' R  D='3.5'




>MENU /GROVER/CUTS/REFITRSEG
>Guidance
Set parameters for the refit of the RSEGs with MC momentum

>COMMAND SMEAR
>Guidance
Smear MC momentum (Gaussian) by N% before the refit - may be zero
>Action KGCRSMEAR
>Parameter
+
NUM 'momentum error(%)' R  D='3.0'




