*CMZ :          02/05/96  17.05.59  by  Hartwig Albrecht
*CMZ :  2.01/02 26/01/96  15.02.37  by  Hartwig Albrecht
*CMZ :  2.01/01 20/09/95  14.46.21  by  HERA-B
*-- Author :    Hartwig Albrecht   12/05/95

      SUBROUTINE KATOPP

************************************************************************
*
* Description: Extend / update Table Of Particle Properties
*
* Called from: KUIP
*
* External references:
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/TOPP.fi"

      INTEGER L, IG1, IG2, IX, IA, CHARGE, COLOUR, DECAY, LUND,
     +  GEANT, GEANTA
      REAL MASS, WIDTH, LIFE, TRBW
      CHARACTER CN*12, CA*12, CNU*12, CAU*12, CC*12

#include "arte/Arte.ff"
#include "auto/TOPP.ff"

      LUNDINIT = - ABS (LUNDINIT)

      CALL KUGETS (CN, L)
      CALL KUGETS (CA, L)
      IF (CA .EQ. '=')  CA = CN
      CALL KUGETR (MASS)
      CALL KUGETI (CHARGE)
      CALL KUGETI (COLOUR)
      CALL KUGETI (DECAY)
      CALL KUGETR (WIDTH)
      CALL KUGETR (TRBW)
      IF (WIDTH .GT. 0)  THEN
        LIFE = HBAR / WIDTH
      ELSE
        LIFE = FLARGEST
      END IF
      LUND = -999
      CALL KUGETI (LUND)
      GEANT = -999
      CALL KUGETI (GEANT)
      GEANTA = -999
      CALL KUGETI (GEANTA)

      CNU = CN
      CALL CLTOU (CNU)
      CAU = CA
      CALL CLTOU (CAU)

      DO 10 IX = 1, NTOPP()
        CALL CHHTOC (IQ(HQTOPP_NAME(1,IX)), CC)
        CALL CLTOU (CC)
        IF (CNU .EQ. CC)  GO TO 20
 10   CONTINUE

      CALL MMBOOK (JTOPP, 1)
      CALL CHCTOH (CN, IQ(HQTOPP_NAME(1,IX)), 3)
      IX = NTOPP()

 20   IF (MASS .GE. 0)   Q(QTOPP_MASS(IX)) = MASS
      IF (WIDTH .GE. 0)  Q(QTOPP_WID(IX)) = WIDTH
      IF (TRBW .GE. 0)  Q(QTOPP_TRBW(IX)) = TRBW
      IF (LIFE .GE. 0)  Q(QTOPP_LIFE(IX)) = LIFE
      IF (CHARGE .GT. -999)  IQ(IQTOPP_CHRG(IX)) = CHARGE
      IF (COLOUR .GT. -999)  IQ(IQTOPP_COLO(IX)) = COLOUR
      IF (DECAY  .GE. 0) IQ(IQTOPP_DECA(IX)) = DECAY
      IF (LUND .NE. -999) IQ(IQTOPP_LUND(IX)) = LUND
      IF (GEANT .NE. -999) IQ(IQTOPP_GEAN(IX)) = GEANT

      IA = IX
      IF (CNU .EQ. CAU)  GO TO 70
      IF (CAU .EQ. ' ')  GO TO 90

      DO 30 IA = 1, NTOPP()
        CALL CHHTOC (IQ(HQTOPP_NAME(1,IA)), CC)
        CALL CLTOU (CC)
        IF (CAU .EQ. CC)  GO TO 40
 30   CONTINUE

      CALL MMBOOK (JTOPP, 1)
      CALL CHCTOH (CA, IQ(HQTOPP_NAME(1,IA)), 3)
      IA = NTOPP()

 40   IF (MASS .GE. 0)   Q(QTOPP_MASS(IA)) = MASS
      IF (WIDTH .GE. 0)  Q(QTOPP_WID(IA)) = WIDTH
      IF (TRBW .GE. 0)  Q(QTOPP_TRBW(IA)) = TRBW
      IF (LIFE .GE. 0)  Q(QTOPP_LIFE(IA)) = LIFE
      IF (CHARGE .GT. -999)  IQ(IQTOPP_CHRG(IA)) = - CHARGE
      IF (COLOUR .GT. -999)  IQ(IQTOPP_COLO(IA)) = COLOUR
      IF (DECAY  .GE. 0) IQ(IQTOPP_DECA(IA)) = DECAY
      IF (LUND .NE. -999)   IQ(IQTOPP_LUND(IA)) = - LUND
      IF (GEANTA .NE. -999) IQ(IQTOPP_GEAN(IA)) = GEANTA

      IF (ITOPP_ANTI(IA) .EQ. 0)  IQ(IQTOPP_ANTI(IA)) = IX
      IF (ITOPP_ANTI(IA) .NE. IX)  GO TO 80

 70   IF (ITOPP_ANTI(IX) .EQ. 0)  IQ(IQTOPP_ANTI(IX)) = IA
      IF (ITOPP_ANTI(IX) .EQ. IA)  GO TO 90

 80   C78 = 'TOPP: contradictory part/antipart relation for'
      CALL CH78BC (CN)
      CALL CH78BC (CA)
      CALL ME78WC (93464513)

 90   END

************************************************************************
* End of KATOPP
************************************************************************
