*CMZ :  1.00/00 22/09/94  20.50.40  by  Fedor Ratnikov
*CMZ :  0.01/02 23/08/94  18.04.11  by  Dominik Ressing
*-- Author :    Dominik Ressing   23/08/94
************************************************************************
*
* L1GEONS
* written by Dominik Ressing, 23/08/94 15.16.48
*
* This routines action:
* the N regions are overlayed and the overlap region is returned.
* If the hit regions overlap the overlap-region is returned --
* else negative sizes for OvLap.
* z is always given by the first region, the stereo angle of the
* overlap region is 0.
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* N          in          number of regions to overlap
* Reg        in          array of regions of type GeoInf
* OvLap      out         overlap region of type GeoInf
*
*
************************************************************************
c
      SUBROUTINE L1GEONS(N,reg,OvLap)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
c
      REAL    Reg(L1GEOINFlen,*),OvLap(L1GEOINFlen)
      INTEGER N
c
      REAL    xmin,xmax,ymin,ymax
      INTEGER ifi,ise
c
c     --- preset boundaries with values for 1st region
      xmin = Reg(L1GEOINFx0,1)
      xmax = xmin + Reg(L1GEOINFsx,1) +
     &     Reg(L1GEOINFsy,1)*ABS(Reg(L1GEOINFsin_al,1)/
     &                             Reg(L1GEOINFcos_al,1))
      ymin = Reg(L1GEOINFy0,1)
      ymax = ymin + Reg(L1GEOINFsy,1)
c
c     --- calculate the cross-section of all squares
      DO ifi=1,N
         DO ise = ifi+1,N
c           --- inter section of the two squares (ALPHA=0.):
            CALL l1geo2s(Reg(1,ifi),Reg(1,ise),OvLap)
            IF ( OvLap(L1GEOINFsx).le.0. ) THEN
               OvLap(L1GEOINFx0) = -999999.
               OvLap(L1GEOINFsx) = -999999.
               OvLap(L1GEOINFy0) = -999999.
               OvLap(L1GEOINFsy) = -999999.
               OvLap(L1GEOINFsin_al) = 0.
               OvLap(L1GEOINFcos_al) = 1.
               OvLap(L1GEOINFz)  = Reg(L1GEOINFz,1)
               RETURN
            ELSE
               xmin = MAX(xmin,OvLap(L1GEOINFx0))
               xmax = MIN(xmax,OvLap(L1GEOINFx0)+OvLap(L1GEOINFsx))
               ymin = MAX(ymin,OvLap(L1GEOINFy0))
               ymax = MIN(ymax,OvLap(L1GEOINFy0)+OvLap(L1GEOINFsy))
            END IF
         END DO
      END DO
c
      IF ( xmin.ge.xmax .or. ymin.ge.ymax ) THEN
         OvLap(L1GEOINFx0) = -999999.
         OvLap(L1GEOINFsx) = -999999.
         OvLap(L1GEOINFy0) = -999999.
         OvLap(L1GEOINFsy) = -999999.
      ELSE
         OvLap(L1GEOINFx0) = xmin
         OvLap(L1GEOINFsx) = xmax-xmin
         OvLap(L1GEOINFy0) = ymin
         OvLap(L1GEOINFsy) = ymax-ymin
      END IF
      OvLap(L1GEOINFsin_al) = 0.
      OvLap(L1GEOINFcos_al) = 1.
      OvLap(L1GEOINFz)  = Reg(L1GEOINFz,1)
c
      RETURN
c
      END
