*CMZ :          01/06/96  22.35.27  by  Fedor Ratnikov
*-- Author :    Fedor Ratnikov   09/02/96
************************************************************************
*
* L1MUSCA
* written by Fedor Ratnikov, 09/02/96 18.04.53
*
* This routines action:
* calculates multiple scattering corrections for muons
*
*----------------------------------------------------------------------*
* iPrevSL     in       previous superlayer
* iCurSL      in       current superlayer
* iNextSL     in       next superlayer
* x0,y0,z0    in       point position
* dx,dy       out      x&y corrections for next SL
************************************************************************
c
      SUBROUTINE L1MUSCA(iPrevSL,iCurSL,iNextSL,x0,y0,z0,dx,dy)
c
      IMPLICIT NONE
c
      INTEGER iPrevSL,iCurSL,iNextSL
      REAL x0,y0,z0,dx,dy
c
#include "l1si/l1param.fi"
c
      REAL dxMU4MU3_MU2,dxMU4MU3_MU1,dxMU3MU2_MU1,dxMU3MU1_TC2,
     &     dxMU2MU1_TC2,dxMU1TC2_TC1
      REAL dyMU3_MU2,dyMU3_MU1,dyMU2_MU1,dyMU1_TC2
      PARAMETER (dxMU4MU3_MU2=34.3)   ! parameters for present
      PARAMETER (dxMU4MU3_MU1=13.4)   ! HERA-B geometry
      PARAMETER (dxMU3MU2_MU1=14.3)
      PARAMETER (dxMU3MU1_TC2=51.4)
      PARAMETER (dxMU2MU1_TC2=43.6)
      PARAMETER (dxMU1TC2_TC1=8.7)
      PARAMETER (dyMU3_MU2=25.2)
      PARAMETER (dyMU3_MU1=40.1)
      PARAMETER (dyMU2_MU1=18.9)
      PARAMETER (dyMU1_TC2=19.4)

      REAL pnom,xx,tanthet,costhet
      REAL A,B                 ! pnom=A/thet+B/thet**2
      DATA A /0.5/, B /0./
c
c
      pnom(xx) = MAX(A/xx+B/xx**2,5.)  ! threshould function
c
c
      tanthet = sqrt(x0**2+y0**2)/z0
      costhet = 1./sqrt(1.+tanthet**2)
      dx = 1./pnom(tanthet)/sqrt(costhet)  ! base value
      dy = dx
      IF(iCurSL.EQ.L1DEFsupMU3)  THEN
       IF(iNextSL.EQ.L1DEFsupMU2)  THEN ! MU4&MU3->MU2
        dx = dxMU4MU3_MU2*dx
        dy = dyMU3_MU2*dy
       ELSE                             ! MU4&MU3->MU1
        dx = dxMU4MU3_MU1*dx
        dy = dyMU3_MU1*dy
       ENDIF
      ELSEIF(iCurSL.EQ.L1DEFsupMU2)  THEN ! MU3&MU2->MU1
       dx = dxMU3MU2_MU1*dx
       dy = dyMU2_MU1*dy
      ELSEIF(iCurSL.EQ.L1DEFsupMU1)  THEN
       IF(iPrevSL.EQ.L1DEFsupMU2)  THEN ! MU2&MU1->TC2
        dx = dxMU2MU1_TC2*dx
       ELSE                             ! MU3&MU1->TC2
        dx = dxMU3MU1_TC2*dx
       ENDIF
       dy = dyMU1_TC2*dy
      ELSEIF(iCurSL.EQ.L1DEFsupTC02)  THEN  ! MU1&TC2->TC1
       dx = dxMU1TC2_TC1*dx
       dy = 0.
      ELSE
       dx = 0.
       dy = 0.
      ENDIF
      IF(iNextSL.EQ.L1DEFsupTC02)  THEN
       dx = dx*T1MUXMSCpar(2)
       dy = dy*T1MUYMSCpar(2)
      ELSEIF(iNextSL.EQ.L1DEFsupTC01)  THEN
       dx = dx*T1MUXMSCpar(3)
       dy = dy*T1MUYMSCpar(3)
      ELSE
       dx = dx*T1MUXMSCpar(1)
       dy = dy*T1MUYMSCpar(1)
      ENDIF
c      if(dx.gt.0.)
c     *     print '(''L1MUSCA=>pre/cur/next/x/y/z/p/dx/dy:''3i3,6f9.2)',
c     *     iPrevSL,iCurSL,iNextSL,x0,y0,z0,pnom(tanthet),dx,dy
      RETURN
c
      END










