*CMZ :  2.01/02 17/01/96  15.17.53  by  Hartwig Albrecht
*CMZ :  2.01/01 20/10/95  11.48.45  by  HERA-B
*-- Author :    Hartwig Albrecht   13/09/95

      SUBROUTINE LILUDE (KC, CTPL)

************************************************************************
*
* Description: Write Lund decay table.
*
* Called from:
*
* External references:
*
* Argument in/out description
*   KC     in     particle number (Lund: "compressed" code)
*   CTPL   in     terminal/printer/log_file
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "jets/LUDAT2.fi"
#include "jets/LUDAT3.fi"
#include "jets/LUDAT4.fi"
#include "jets/LUCODE.fi"
#include "auto/TOPP.fi"

      INTEGER L, KC, K, K1, K2, I, J, TPLUAR, LENOCC
      CHARACTER CNAME*12, CDECA*12, CTPL*(*)

#include "arte/Arte.ff"
#include "auto/TOPP.ff"

      IF (KC .EQ. 0)  THEN
        K1 = 1
        K2 = 500
      ELSE
        K1 = KC
        K2 = KC
      END IF

      DO 40 L = 1, 3
        IF (LIOTPL(L) .EQ. 0)  GO TO 40

        DO 30 K = K1, K2

          IF (LCOD(K) .EQ. 0 .OR. MDCY(K,3) .EQ. 0)  GO TO 30

          CALL CHHTOC (IQ(HQTOPP_NAME(1,LCOD(K))), CNAME)
          WRITE (LIOTPL(L), 1001)  ' BEGdecay ', CNAME

          DO 20 I = MDCY(K,2), MDCY(K,2) + MDCY(K,3) - 1
            C78 = ' '
            DO 10 J = 1, 5
              IF (KFDP(I,J) .EQ. 0)  GO TO 10
              CALL CHHTOC (IQ(HQTOPP_NAME(1,TPLUAR(KFDP(I,J)))), CDECA)
              CALL CH78BC (CDECA)
 10         CONTINUE
            WRITE(LIOTPL(L),1002)
     +        MDME(I,1),MDME(I,2),BRAT(I),C78(1:LENOCC(C78))
 20       CONTINUE

          WRITE (LIOTPL(L), 1001)  ' ENDdecay ', CNAME

 30     CONTINUE

 40   CONTINUE

 1001 FORMAT (2A)
 1002 FORMAT (4X,'decay',I3,I4,F9.5,A)

      END

************************************************************************
* End of LILUDE
************************************************************************
