// created by       Olya Igonkina     20.07.1999
// routine which check threshold on cluster. 
// Cut common for all MARPLE matches 

#include <math.h>
#include "arte/arte.hh"

extern int maTakeRccl(float threshold, ArtePointer<RCCL> rccl );

int maTakeRccl(float threshold_cut, ArtePointer<RCCL> rccl )
{
  if( threshold_cut > 200 )
    {
      // Ktrig cut
      float radius = sqrt( rccl->x*rccl->x + 
			   rccl->y*rccl->y);
      float radMag = sqrt( rccl->x*rccl->x + 
			   fabs(rccl->y*rccl->y*rccl->y) );
      if( radMag && radius && 
	  rccl->esum > threshold_cut * ( 1/radius+1/radMag ) )
	return 1;
    }else{
      // pt_cut
      float radius = sqrt( rccl->x*rccl->x + rccl->y*rccl->y);
      float Et = rccl->esum * radius/
	sqrt( radius*radius + rccl->z*rccl->z );
      if( Et > threshold_cut ) return 1 ;
    }
return  0;
}
