
// Boris Fominykh  16.12.99
// code and decode the muon chamber/cable name (Rob's classification)

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <iostream.h>

extern "C" {
int MuNameDecode(char* Name,int* Type,int* Msl,int* Lay,int* Ud,int* NxQu,int* Nc)
{
  *Type=0;
  *Msl =0;
  *Lay =0;
  *Ud  =0;
  *NxQu=0;
  *Nc  =0;

  char namew[10];
  strncpy(namew,Name,10);

// control for sure
  char* chM = "M";
  char ch = namew[0];
  if(ch != *chM) return 1;
  char* chd = ".";
  ch = namew[3];
  if(ch != *chd) return 1;

  char* chx = "x";
  ch = namew[1];
  if(ch == *chx) namew[8]=' ';
  namew[9]='\0';

  char numb[11] = "0123456789";
  char* cht = "t";
  char* chp = "p";

// muon superlayer
  int msl=-1;
  ch = namew[2];
  for(int i=0; i<11; i++) {
    char chn = numb[i]; 
    if(chn == ch) {
      msl = i;
      break;
    }
  }
  if(msl < 1) return 2;  

// minor
  int minr=-1;
  ch = namew[4];
  for(int i=0; i<11; i++) {
    char chn = numb[i]; 
    if(chn == ch) {
      minr = i;
      break;
    }
  }
  if(minr < 1) return 3;  

// type
  ch = namew[1];
  int type = 0;
  if(ch == *cht && msl >= 1 && msl < 3) type=1; // tube wires
  if(ch == *cht && msl > 2) type=2;             // pad wires
  if(ch == *chp && msl > 2) type=3;             // pads
  if(ch == *chx)           type=4;              // pixels
  if(type < 1) return 4;  

// chamber number
  int nx = 0;
  char* chm = "-";
  ch = namew[5];
  if(ch == *chm) {
    int nx1 = 0;
    ch = namew[6];
    for(int i=0; i<11; i++) {
      char chn = numb[i]; 
      if(chn == ch) {
        nx1 = i;
        break;
      }
    }
    int nx2 = 0;
    ch = namew[7];
    for(int i=0; i<11; i++) {
      char chn = numb[i]; 
      if(chn == ch) {
        nx2 = i;
        break;
      }
    }
    nx = 10*nx1+nx2;
  }

// the case of pixels 
  if(type == 4) {
    *Type=type;
    *Msl =msl;
    if(msl <3) *Lay =4;
    else       *Lay =2;
    *Ud  =0;
    *NxQu=minr;
    *Nc  =nx;
    return 0;
  }
  
// tube and pad chambers
  if(type < 4) {
    if(nx < 1) return 5;
    *Type=type;
    *Msl =msl;
    *NxQu=nx;
    *Lay =(minr+1)/2;
    *Ud  =(minr-1)%2;
// decode connector number
    ch = namew[8];
    char* chA = "A";
    char* chB = "B";
    if(ch == *chA) *Nc=1;
    if(ch == *chB) *Nc=2;
    if(type == 3) {
      char* chC = "C";
      char* chD = "D";
      if(ch == *chC) *Nc=3;
      if(ch == *chD) *Nc=4;
    }
  }
  return 0;
}

int MuNameCode(char* Name,int* Type,int* Msl,int* Lay,int* Ud,int* NxQu,int* Nc)
{
// control for sure
  if(*Type < 1 || *Type > 4)  return 1;
  if(*Msl < 1  || *Msl > 4)   return 2;
  if(*Lay < 1  || *Lay > 3)   return 3;
  if(*Ud < 0   || *Ud > 1)    return 4;
  if(*NxQu < 1 || *NxQu > 99) return 5;

  char numb[11] = "0123456789";
  char* chM = "M";
  char* chx = "x";
  char* cht = "t";
  char* chp = "p";
  char* chd = ".";
  char* chm = "-";
  char* chs = " ";
  char* chA = "A";
  char* chB = "B";
  char* chC = "C";
  char* chD = "D";

  char namew[10];
  namew[0]=*chM;
  if(*Type < 3) namew[1]=*cht;
  if(*Type == 3) namew[1]=*chp;
  if(*Type == 4) namew[1]=*chx;
  namew[2]=numb[*Msl];
  namew[3]=*chd;
// pixels
  if(*Type == 4) {
    if(*NxQu > 4) return 5;
    namew[4]=numb[*NxQu];
// connector
    if(*Nc > 0 && *Nc < 25) {
      int n1=*Nc/10;
      int n2=*Nc%10;
      namew[5]=*chm;
      namew[6]=numb[n1];
      namew[7]=numb[n2];
      namew[8]=*chs;
    }
    else {
      for(int i=5; i<9; i++) namew[i]=*chs;
    }
    goto goodexit;
  }
// tubes and pads
  else {
    int minr=2*(*Lay-1)+(*Ud)+1;
    namew[4]=numb[minr];
// chamber number
    namew[5]=*chm;
    int n1=*NxQu/10;
    int n2=*NxQu%10;
    namew[6]=numb[n1];
    namew[7]=numb[n2];
// connector
    if(*Nc > 0 && ((*Type < 3 && *Nc < 2) || (*Type == 3 && *Nc < 5))) {
      if(*Nc == 1) namew[8]=*chA;
      if(*Nc == 2) namew[8]=*chB;
      if(*Nc == 3) namew[8]=*chC;
      if(*Nc == 4) namew[8]=*chD;
    }
    else {
      namew[8]=*chs;
    }
    goto goodexit;
  }
  return 6;
goodexit:
  namew[9]='\0';
  strncpy(Name,namew,10);
  return 0;
}
}


