/************************************************************************
*
* jsMuPixTool.C
* 
* first author : Jing-Ge Shiu 
* purpose      : head file for jsMuPixTool.C
* called from  : 
* includ file  : murec/MuDbPixelArte.h
* start date   : May. 09, 2000
*
*
*-----------------------------------------------------------------------
* 
*/

#include <iomanip.h>
#include "arte/arte.hh"
#include "murec/MuDbPixelArte.h"

#define MAX(a,b)  a>b?a:b
#define MIN(a,b)  a<b?a:b

struct TWOINT {
  int i1, i2;                                 
};

struct TWOFLOAT {
  float f1, f2;                               
};

struct FOURFLOAT {
  TWOFLOAT x,y;
};


struct VP2PIX {
  int    npix;  
  TWOINT pixid[6];
};


class MXPIX : public MuPixChamber {
  public :   
     MXPIX();
     ~MXPIX();
     MXPIX(const MXPIX&);
     static const int MaxPixCol = 48;
     static const int MaxPixRow = 36;
     static const int MaxVpCol = 48;
     static const int MaxVpRow = 17;
     static const int MaxNhit = 30;

     TWOINT pix_vp[Sl][MaxPixCol][MaxPixRow];
     TWOINT vp_readout[Sl][MaxVpCol][MaxVpRow];
     int    nordpix[Sl][MaxPixRow];
     Word   Nxrd[Sl], Nyrd[Sl];
     
     void   printpix2vp(int);
     void   printropix(int);
     void   printvp2rd(int);
     TWOINT getxy2pix(int, int, float, float);
     
  protected:
     TWOINT pix_rdvp[Sl][MaxPixCol][MaxPixRow];
     VP2PIX vp_pix[Sl][MaxVpCol][MaxVpRow];

  private :
     void nonereadpix();
     void buildpix2vp();
     void buildvp2rd();

};










