*  B.Fominykh  21.07.97
* add MU3, MU4 wires to pad seed, make the kalman filter seed 
* and make the tree branch from the seed 
* updated 10.04.99 by B.Fominykh - 2 pad wires are bloked
* updated 28.04.2000 by B.Fominykh - 2 pad wires unbloked ("soft" version)
*
* INPUT:  IPP(4)    - pointers to MU3 and MU4 linked pad clusters
C
      SUBROUTINE MURWIR(IPP)
C-    ======================
      IMPLICIT NONE
      INTEGER IPP(4)
#include "murec/MUCPAR.fi"
#include "murec/MUCONT.fi"
#include "murec/MUCTAB.fi"
#include "murec/MUCZDT.fi"
      INTEGER I,J,II,JP,IRL,IC,JC,IW,IL,IOUT,ISTAR,IDBPR
      INTEGER IBLOK2,IBLOK3
      INTEGER I1,I2,I3,I4,IF,JF,JL,JJ,NWIR,IPWIR(4)
      REAL XW,COEF,YPD(2),X1(2),X2(2),DD,TX,AX
      INTEGER NPD(2),NRL(4),NWR(4),IPWR(4,20)
#include "arte/Arte.fi"
#include "arte/Arte.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
*
* y-range and reco layers for selection of wires
      COEF=SQRT(12.)
      CALL VZERO(NRL,4)
      CALL VZERO(NPD,2)
      YPD(1)=0.
        YPD(2)=0.
      II=0
      DO I=1,2
        X1(I)=1000.
        X2(I)=-1000.
        DO J=1,2
          II=II+1
          IF(IPP(II).GT.0) THEN
            JP=JTMP8+IQ(JTMP8+1)*(IPP(II)-1)+2
            XW=Q(JP+8)-COEF*Q(JP+11)-1.
            IF(XW.LT.X1(I)) X1(I)=XW
            XW=Q(JP+8)+COEF*Q(JP+11)+1.
            IF(XW.GT.X2(I)) X2(I)=XW
            YPD(I)=YPD(I)+Q(JP+9)
            NPD(I)=NPD(I)+1
            IRL=IQ(JP+2)
            IF(IRL.EQ.20.OR.IRL.EQ.24.OR.IRL.EQ.30.OR.IRL.EQ.34) THEN
              NRL(2*I-1)=IRL-1
              NRL(2*I)  =IRL+2
            ENDIF
            IF(IRL.EQ.21.OR.IRL.EQ.25.OR.IRL.EQ.31.OR.IRL.EQ.35) THEN
              NRL(2*I-1)=IRL-2
              NRL(2*I)  =IRL+1
            ENDIF
          ENDIF
        ENDDO
        IF(NPD(I).GT.0) YPD(I)=YPD(I)/FLOAT(NPD(I))
      ENDDO
*
      IF(IPRLG.GE.4) THEN
      WRITE(LLOGF,1001) (NRL(2*J-1),NRL(2*J),X1(J),X2(J),J=1,2)
 1001 FORMAT(1X,'RL,X MU3:',2I3,2F8.2,' RL,X MU4:',2I3,2F8.2)
      WRITE(LLOGF,1002) (NPD(J),YPD(J),J=1,2)
 1002 FORMAT(1X,'N,Y pad MU3:',I2,F8.2,' N,Y pad MU4:',I2,F8.2)
      ENDIF
*
* preselection of wires using pad X-position
      DO 20 IL=1,4
        IRL=NRL(IL)
        IF(IRL.LE.0) GOTO 20
        NWR(IL)=0
        IF(NMUACL(IRL).LE.0) GOTO 20
        II=(IL+1)/2
        DO 10 IC=1,NMUCLL(IRL)
          JC=JTMP8+IQ(JTMP8+1)*(JCLPT1(IRL)+IC-2)+2
          IF(IQ(JC+1).NE.1) GOTO 10
          IF(IQ(JC+5).NE.1) GOTO 10
          XW=Q(JC+8)
          IF(XW.LT.X1(II)) GOTO 10
          IF(XW.GT.X2(II)) GOTO 10
          IW=NWR(IL)+1
          IF(IW.GT.20) GOTO 10
          NWR(IL)=IW
          IPWR(IL,IW)=JCLPT1(IRL)+IC-1
 10     CONTINUE
 20   CONTINUE
* debug print
      IF(IPRLG.GE.4) THEN
      DO 25 IL=1,4
        IF(NWR(IL).GT.0) THEN
         WRITE(LLOGF,1003)IL,NRL(IL),NWR(IL),(IPWR(IL,J),J=1,NWR(IL))
 1003    FORMAT(1X,2I3,' Nwir',I3,' IP:',50I3)
        ELSE
         WRITE(LLOGF,1004)IL,NRL(IL)
 1004     FORMAT(1X,2I3,'  no selected wires')
        ENDIF
  25  CONTINUE
      ENDIF
*
* at least 1 wire in MU3 and MU4
      IF(NWR(1).EQ.0.AND.NWR(2).EQ.0) GOTO 999
      IF(NWR(3).EQ.0.AND.NWR(4).EQ.0) GOTO 999
* residual filter
      NWIR=0
      DO I=1,4
        IF(NWR(I).GT.0) NWIR=NWIR+1
      ENDDO

***      IF(NWIR.LT.3) GOTO 101
      IF(NWIR.LT.2) GOTO 101
*
      CALL VZERO(IPWIR,4)
      IF=0
          IL=0
* use both 2 and 3 pad wires 
      IBLOK2=0
      IBLOK3=0
      DO 90 I1=1,NWR(1)+1
       IF(I1.LT.NWR(1)+1) THEN
        IPWIR(1)=IPWR(1,I1)
        IF(IF.EQ.0) IF=1
       ELSE
        IPWIR(1)=0
        IF=2
       ENDIF
       DO 80 I2=1,NWR(2)+1
        IF(I2.LT.NWR(2)+1) THEN
         IPWIR(2)=IPWR(2,I2)
         IF(IF.EQ.0) IF=2
        ELSE
         IPWIR(2)=0
         IF=1
        ENDIF
        DO 70 I3=1,NWR(3)+1
         IF(I3.LT.NWR(3)+1) THEN
          IPWIR(3)=IPWR(3,I3)
          IL=3
         ELSE
          IPWIR(3)=0
          IL=4
         ENDIF
         DO 60 I4=1,NWR(4)+1
          IF(I4.LT.NWR(4)+1) THEN
           IPWIR(4)=IPWR(4,I4)
           IL=4
          ELSE
           IPWIR(4)=0
           IL=3
          ENDIF
*
          NWIR=0
          DO I=1,4
            IF(IPWIR(I).GT.0) NWIR=NWIR+1
          ENDDO
          IF(NWIR.LT.2) GOTO 60
          IF(NWIR.EQ.3.AND.IBLOK3.EQ.1) GOTO 60
          IF(NWIR.EQ.2.AND.IBLOK2.EQ.1) GOTO 60
          IF(IL.EQ.IF) GOTO 60
          IF(IPWIR(IF).LE.0) GOTO 60
          IF(IPWIR(IF).GT.IQ(JTMP8+2)) GOTO 60
          IF(IPWIR(IL).LE.0) GOTO 60
          IF(IPWIR(IL).GT.IQ(JTMP8+2)) GOTO 60
          DD=0.
          JF=JTMP8+IQ(JTMP8+1)*(IPWIR(IF)-1)+2
          JL=JTMP8+IQ(JTMP8+1)*(IPWIR(IL)-1)+2
          TX=(Q(JL+8)-Q(JF+8))/(Q(JL+6)-Q(JF+6))
          IF(ABS(TX).GT.1.E-7) THEN
            AX=Q(JF+8)-Q(JF+6)*TX
          ELSE
            AX=Q(JF+8)
          ENDIF
          DO 50 I=IF+1,IL-1
            IF(IPWIR(I).EQ.0) GOTO 50
            JJ=JTMP8+IQ(JTMP8+1)*(IPWIR(I)-1)+2
            IF(ABS(TX).GT.1.E-7) THEN
             DD=DD+(Q(JJ+8)-Q(JJ+6)*TX-AX)**2
            ELSE
             DD=DD+(Q(JJ+8)-AX)**2
            ENDIF
  50      CONTINUE
*
* debug print
          IF(IPRLG.GE.4)
     +     WRITE(LLOGF,1005)NWIR,IF,IL,IPWIR,DD
 1005     FORMAT(1X,'Nwir',I2,' IF,IL',2I2,
     +             '  IP:',4I4,' DD',E12.4)
*
* make a Kalman filter seed for the branch grouth in the case of 4 wires
          IF(NWIR.EQ.4.AND.DD.LT.DDWMX4) THEN
           CALL MURBRSD(IPP,IPWIR,IOUT)
           IF(IOUT.NE.0) GOTO 60
* make a branch on a tree from the seed
           ISTAR=IFREE-1
           IDBPR=0
           IF(IPRLG.GE.6) IDBPR=1
           CALL MURBRGR(ISTAR,IDBPR)
* block 2,3-wires seeds
           IBLOK2=1
           IBLOK3=1
          ENDIF
* make a Kalman filter seed for the branch grouth in the case of 3 wires
          IF(IBLOK3.EQ.0.AND.NWIR.EQ.3.AND.DD.LT.DDWMX3) THEN
           CALL MURBRSD(IPP,IPWIR,IOUT)
           IF(IOUT.NE.0) GOTO 60
* make a branch on a tree from the seed
           ISTAR=IFREE-1
           IDBPR=0
           IF(IPRLG.GE.6) IDBPR=1
           CALL MURBRGR(ISTAR,IDBPR)
* block 2-wires seeds
           IBLOK2=1
          ENDIF
* make a Kalman filter seed for the branch grouth in the case of 2 wires
          IF(IBLOK2.EQ.0.AND.NWIR.EQ.2) THEN
           CALL MURBRSD(IPP,IPWIR,IOUT)
           IF(IOUT.NE.0) GOTO 60
* make a branch on a tree from the seed
           ISTAR=IFREE-1
           IDBPR=0
           IF(IPRLG.GE.6) IDBPR=1
           CALL MURBRGR(ISTAR,IDBPR)
          ENDIF
  60     CONTINUE
  70    CONTINUE
  80   CONTINUE
  90  CONTINUE
*
  101 CONTINUE
*
 999  CONTINUE
      RETURN
      END
