/* Inserts misc. figure types (defined in SetupFigureExamples class from 
   setup_figure_examples.hh) to setup_figure_istream_menu.
*/

// Author V.Balagura (balagura@mail.desy.de)   (24.04.98).

#include "ptset/setup_figure_istream_menu.hh"
#include "ptset/setup_figure_examples.hh"
#include "ptset/call_via_istr.hh"

IstreamMenu_1Par<SetupFigureBase**>& setup_figure_istream_menu() {
  static IstreamMenu_1Par<SetupFigureBase**> menu;

  struct _FillSetupFigureIstreamMenu {
    _FillSetupFigureIstreamMenu(IstreamMenu_1Par<SetupFigureBase**>& m) {
      m.parser = new SlashBlock_InteractiveParser;
      m("rectangle") = make_interactive_command_1par 
	(call_via_istr_1par(setup_figure_maker
			    (SetupFigureExamples::rectangle, 
			     (Rectangle*)0),
			    (Rectangle*)0, (SetupFigureBase***)0),
	 (SetupFigureBase***)0);
      m("rectangle_with_hole") = make_interactive_command_1par 
	(call_via_istr_1par
	 (setup_figure_maker(SetupFigureExamples::rectangle_with_hole, 
		       (Rectangle*)0, (Rectangle*)0),
	  (Rectangle*)0, (Rectangle*)0, (SetupFigureBase***)0),
	 (SetupFigureBase***)0);
      m("rectangle_center_at_0") = make_interactive_command_1par 
	(call_via_istr_1par
	 (setup_figure_maker(SetupFigureExamples::rectangle_center_at_0, 
		       (Point*)0),
	  (Point*)0, (SetupFigureBase***)0),
	 (SetupFigureBase***)0);
      m("rectangle_with_hole_center_at_0") =
	make_interactive_command_1par 
	(call_via_istr_1par
	 (setup_figure_maker
	  (SetupFigureExamples::rectangle_with_hole_center_at_0, 
	   (Point*)0, (Point*)0),
	  (Point*)0, (Point*)0, (SetupFigureBase***)0),
	 (SetupFigureBase***)0);
      m("rectangle_with_hole_center_at_0_bite_at_bottom") =
	make_interactive_command_1par 
	(call_via_istr_1par
	 (setup_figure_maker
	  (SetupFigureExamples::rectangle_with_hole_center_at_0_bite_at_bottom, 
	   (Point*)0, (Point*)0, (double*)0, (double*)0, (double*)0),
	  (Point*)0, (Point*)0, (double*)0, (double*)0, (double*)0, 
	  (SetupFigureBase***)0),
	 (SetupFigureBase***)0);
      m("cross") = make_interactive_command_1par 
	(call_via_istr_1par
	 (setup_figure_maker(SetupFigureExamples::cross, (Rectangle*)0),
	  (Rectangle*)0, (SetupFigureBase***)0), (SetupFigureBase***)0);
      m("cross_center_at_0") = make_interactive_command_1par 
	(call_via_istr_1par
	 (setup_figure_maker(SetupFigureExamples::cross_center_at_0, 
		       (Point*)0),
	  (Point*)0, (SetupFigureBase***)0),
	 (SetupFigureBase***)0);
      m("plus") = make_interactive_command_1par 
	(call_via_istr_1par
	 (setup_figure_maker(SetupFigureExamples::plus, 
		       (Rectangle*)0, (Rectangle*)0),
	  (Rectangle*)0, (Rectangle*)0, (SetupFigureBase***)0),
	 (SetupFigureBase***)0);
      m("plus_center_at_0") = make_interactive_command_1par 
	(call_via_istr_1par
	 (setup_figure_maker(SetupFigureExamples::plus_center_at_0, 
		       (Point*)0, (Point*)0),
	  (Point*)0, (Point*)0, (SetupFigureBase***)0),
	 (SetupFigureBase***)0);
      m("plus_with_hole_center_at_0") = make_interactive_command_1par 
	(call_via_istr_1par
	 (setup_figure_maker
	  (SetupFigureExamples::plus_with_hole_center_at_0, 
	   (Point*)0, (Point*)0, (Point*)0),
	  (Point*)0, (Point*)0, (Point*)0, (SetupFigureBase***)0),
	 (SetupFigureBase***)0);
      m("rotated_H_with_hole_center_at_0") = make_interactive_command_1par 
	(call_via_istr_1par
	 (setup_figure_maker
	  (SetupFigureExamples::rotated_H_with_hole_center_at_0, 
	   (Point*)0, (Point*)0, (Point*)0),
	  (Point*)0, (Point*)0, (Point*)0, (SetupFigureBase***)0),
	 (SetupFigureBase***)0);
      m("symmetric_plus_center_at_0") = make_interactive_command_1par 
	(call_via_istr_1par
	 (setup_figure_maker
	  (SetupFigureExamples::symmetric_plus_center_at_0, 
	   (double*)0, (double*)0),
	  (double*)0, (double*)0, (SetupFigureBase***)0),
	 (SetupFigureBase***)0);
      m("up_down_symmetric_rectangles_center_at_0") =
	make_interactive_command_1par 
	(call_via_istr_1par
	 (setup_figure_maker
	  (SetupFigureExamples::up_down_symmetric_rectangles_center_at_0, 
		       (double*)0, (double*)0, (double*)0),
	  (double*)0, (double*)0, (double*)0, (SetupFigureBase***)0),
	 (SetupFigureBase***)0);
      m("C_half_at_0") = make_interactive_command_1par 
	(call_via_istr_1par
	 (setup_figure_maker(SetupFigureExamples::C_half_at_0, 
		       (Rectangle*)0, (double*)0, (double*)0, (double*)0),
	  (Rectangle*)0, (double*)0, (double*)0, (double*)0,
	  (SetupFigureBase***)0),
	 (SetupFigureBase***)0);
      m("mirror_C_half_at_0") = make_interactive_command_1par 
	(call_via_istr_1par
	 (setup_figure_maker(SetupFigureExamples::mirror_C_half_at_0, 
		       (Rectangle*)0, (double*)0, (double*)0, (double*)0),
	  (Rectangle*)0, (double*)0, (double*)0, (double*)0,
	  (SetupFigureBase***)0),
	 (SetupFigureBase***)0);
    }
  };
  static _FillSetupFigureIstreamMenu
    _fill_setup_figure_istream_menu(menu);
  return menu;
}
