// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 
#ifndef rangerScatThick_ICC
#define rangerScatThick_ICC

#include <iostream.h>
#include <math.h>
#include "rang/ScatThick.hh"

rangerScatThick::rangerScatThick(double msEff, double Qp, 
				       double Tx, double Ty, double d) :
  rangerScatThin(msEff, Qp, Tx, Ty)


{


  // angular covariance matrix elements defined by rangerScatThin 
  // remain unchanged

  cXX = cTxTx * d * d / 3.; // d is assumed to be the signed thickness
  cXY = cTxTy * d * d / 3.;
  cYY = cTyTy * d * d / 3.;
  cXTx = cTxTx * d * .5;
  cXTy = cTxTy * d * .5;
  cYTx = cTxTy * d * .5;
  cYTy = cTyTy * d * .5;

}

void rangerScatThick::myList() {
  cout << " cXX=" << cXX
       << " cXY=" << cXY
       << " cYY=" << cYY
       << " cXTx=" << cXTx
       << " cXTy=" << cXTy
       << " cYTx=" << cYTx
       << " cYTy=" << cYTy
       << endl;
}

#endif
