// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerHitMap
// stores history information for a node

#ifndef rangerHitMap_HH
#define rangerHitMap_HH

#include <list.h>
#include "arte/arte.hh"

class rangerNode;

class rangerHitMap {

public:
  rangerHitMap(){};
  rangerHitMap(rangerNode* np,ArtePointer<RHIT> rhit){
    node = np; rh = rhit; rp=0;};
  rangerHitMap(rangerNode* np){ node = np; rh = 0; rp = 0;};

  ~rangerHitMap(){};

  const ArtePointer<RHIT> getRhit() const { return rh; };
  const ArtePointer<RPNT> getRpnt() const { return rp; };
  void setRpnt( const ArtePointer<RPNT> rpset ) { rp = rpset; };
  rangerNode* getNode() const { return node; };
  void dump() const;
  friend int operator==(const rangerHitMap hm1, 
			const rangerHitMap hm2);

private:
  rangerNode* node;     // pointer to node
  ArtePointer<RHIT> rh; // pointer to associated RHIT row
  ArtePointer<RPNT> rp; // pointer to associated RPNT row

};

int operator==(const rangerHitMap hm1, 
	       const rangerHitMap hm2);

#endif
