// 
//  Author:  Rainer Mankel                     Created:  01-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerSNMList

#ifndef RANGER_SNMLIST_HH
#define RANGER_SNMLIST_HH

#include <vector.h>

class rangerSNMList {

public:
  rangerSNMList(){};
  ~rangerSNMList(){ for (vector<rangerSNM*>::iterator i=SNMs.begin();
			 i != SNMs.end(); ++i) delete *i;
  SNMs.erase(SNMs.begin(),SNMs.end());
  };

  void add(rangerSNM* s){ SNMs.push_back(s); }
  rangerSNM* getSNM(int cmp,int sec) const {
    for (vector<rangerSNM*>::const_iterator i=SNMs.begin();
	 i != SNMs.end(); ++i) {
      if ((*i)->cmp() == cmp && (*i)->sec() == sec) {
// 	cout << " getSNM: return position " << i - SNMs.begin() << endl;
	return (*i);
      }
    }
    return 0;
  };

  void dump(const int level=1) {
    cout << "SNMList dump ====================="  << endl;
    for (vector<rangerSNM*>::iterator i=SNMs.begin();
	 i != SNMs.end(); ++i) {
      (*i)->dump(level-1);
    }
  }

  void test(const int level=1) {
    cout << "SNMList test ====================="  << endl;
    for (vector<rangerSNM*>::iterator i=SNMs.begin();
	 i != SNMs.end(); ++i) {
      (*i)->test(level-1);
    }
  }

private:
  vector<rangerSNM*> SNMs;
};

#endif  
