// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerThin
// abstract base class for thin multiple scattering object

#ifndef rangerThin_HH
#define rangerThin_HH

#include "arte/arte.hh"
#include "rang/Node.hh"


class rangerThin : public rangerNode {

public:

  rangerThin(){};
  rangerThin(rangerFitMode fm) : rangerNode(fm) {};
  virtual ~rangerThin(){};   // virtual destructor
  
  virtual float ms() const=0;
  virtual float msPlain() const=0;
  virtual float dz()=0;
  virtual int plane()=0;

  virtual void processNoise(rangerParticleType pType);  
                         // apply process noise to state of this node
  virtual void predProcessNoise(rangerParticleType pType);  
                         // apply process noise to state of  node

protected:

private:

};

#endif
