// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerVolTrd2
// volume class for trapezoid (type 2)

#ifndef rangerVolTrd2_HH
#define rangerVolTrd2_HH

#include "rang/Volume.hh"
#include "rang/GeWa.hh"

class rangerVolTrd2 : public rangerVolume {
  
public:
  rangerVolTrd2(); // default constructor
  rangerVolTrd2( rangerGeWa* gewa ); // constructor from gewa
  ~rangerVolTrd2(); // destructor
  double sLength(double zz,
		 double x,
		 double y,
		 double tx,
		 double ty); // scaled length trajectory passes through volume

};

#endif
