*-- Author :    Rainer Mankel   16/07/96
*-- changed:    A.Spiridonov    12/11/98
*  zmax_mag_zfpar = 682.,upper z bound of magnet   26/07/00 A. Spiridonov
*  whit_cmp_zfpar(1) = 2.,                         13/08/00 A. Spiridonov  
*  set parameter sline_mode_zfpar                  19/08/00 A. Spiridonov
*  set parameter slt_mode_zfpar                    03/09/00 A. Spiridonov
*  set param. slt_magn_,tc_mode_,slt_clone_zfpar   01/11/00 A. Spiridonov
* 
      subroutine tf1init()

*     **** initialize the ranger parameters
*     **** called by rginit
      implicit none
      integer ii
#include "rang/zfpar.fi"
#include "rang/zfpar_tc.fi"
#include "rang/zfmode.fi"
#include "rang/zfout.fi"
#include "rang/zfconst.fi"
#include "rang/FLAGWhit.hh"

      call tfversion()          ! print version #
      call dmdef()              ! define default domain table
      call rgdef()

      dlevel_zfpar = 9          ! will be checked in tfrinit

      rlevel_zfpar = 4          ! default run level
      smooth_zfpar = 1          ! smoothing in ranger fit
      niter_zfpar  = 1          ! # iterations in ranger fit
      msmode_zfpar = 3          ! mode for mult scat correction
      max_plpick_zfpar = 199    ! max #planes picked up in ms corr
      maxflt_patx_zfpar = 3     ! max #faults in sequence (pat area,x)
      maxflt_paty_zfpar = 3     ! max #faults in sequence (pat area,y)
      maxflt_3d_zfpar   = 3     ! max N_faults in sequence (3D)
      maxflt_mag_zfpar = 2      ! max #faults in sequence (mag area)
      maxflt_TC_zfpar = 1       ! max #faults in sequence (TC area)

      rmax_x_zfpar = 5          ! max rank x tracking
      rmax_y_zfpar = 5          ! max rank y tracking
      rmax_TC_zfpar= 5          ! max rank of TC tracking

      minmimp_pref_zfpar = 18   ! min #mimps for pat ref track

      cxxrf_zfpar   = 16.       ! initial cov matrix elements
      cyyrf_zfpar   = 50.       !              in ranger fit
      ctxtxrf_zfpar = 1.        !
      ctytyrf_zfpar = 1.        !
      cqqrf_zfpar   = 1.738     !

      f_moliere_zfpar = 2.9     ! m.s. correction from moliere scat

      f_cov_zfpar(1) = 1.       ! fudge factors for covariance matrix
      f_cov_zfpar(2) = 1.
      f_cov_zfpar(3) = 1.
      f_cov_zfpar(4) = 1.
      f_cov_zfpar(5) = 1.

      wchi_x_zfpar = .1    ! quality function chi**2 weight x tracking
      wchi_y_zfpar = .05   ! quality function chi**2 weight y tracking
      wchi_3d_zfpar = .1   ! quality function chi**2 weight 3d tracking
      wchi_mag_zfpar = .05 ! quality function chi**2 weight mag tracking
      wchi_TC_zfpar = .05  ! quality function chi**2 weight TC tracking

      do ii=1,maxcmp_zfpar
         whit_cmp_zfpar(ii) = 1. ! hit weight according to cmp
      enddo
      whit_cmp_zfpar(1) = 2.     ! hit weight VDS according to cmp
      whit_cmp_zfpar(3) = 2.     ! hit weight ITR according to cmp

      chmax_x_zfpar   = 8.  ! max chi**2 in filter step x tracking
      chmax_y_zfpar   = 16. ! max chi**2 in filter step y tracking
      chmax_3d_zfpar  = 8.  ! max chi**2 in filter step 3d tracking
      chmax_mag_zfpar = 16. ! max chi**2 in filter step mag tracking
      chmax_TC_zfpar = 16.  ! max chi**2 in filter step TC tracking

      whitmin_x_zfpar   = 8. ! minimal whit for maturity x tracking
      whitmin_y_zfpar   = 8. ! minimal whit for maturity y tracking
      whitmin_3d_zfpar  = 9. ! minimal whit for maturity 3d tracking
#ifdef RT_WHIT
      whitmin_mag_zfpar = 9. ! minimal whit for maturity mag tracking
#else
      whitmin_mag_zfpar = 3. ! minimal whit for maturity mag tracking
#endif
      whitmin_TC_zfpar = 4.  ! minimal whit for maturity TC tracking

      quality_TC_min =3.4    ! minimal quality_ft() for TC track
      
      qplimit_zfpar = 4.17

      zmin_ec_zfpar = 250.      ! lower z bound for energy loss corr
      zmax_ec_zfpar = 650.      ! upper z bound for energy loss corr

      zmin_mag_zfpar = 190.     ! lower z bound for magnet-type tracking
      zmax_mag_zfpar = 682.     ! upper z bound for magnet-type tracking
      zmin_TC_zfpar = 1175.     ! lower z bound for TC tracking
      zmax_TC_zfpar = 1330.     ! upper z bound for TC type tracking

      dzpara_mag_zfpar = 20.    ! max dz for parabolic expansion

      segstor_zfpar = .true.    ! store in track table

      f_p_zfpar = 0.            ! coefficient of momentum process noise
      f_molRF_zfpar = 1.        ! moliere factor for mult scat in r++ fit

      llog_zfout = .false.      ! initial output levels
      lref_zfout = .false.
      lrec_zfout = .false.
      leff_zfout = .false.

      tI_zfconst = 0.           ! initialize zfconst
      dOff_zfconst = 0.
      sigI_zfconst = 1.

      l_rinit = .false.         ! mark rinit as not yet done

      rlevel_fit = 0            ! default fit level

      qualmin_x_zfpar = 7.      ! minimal quality after x propagation
      qualmin_y_zfpar = 7.      ! minimal quality after y propagation
      nhitmin_y_zfpar = 8       ! minimal number of hits after y propagation

      whitmin_mcon_zfpar = 0.   ! minimal continuation weight in magnet

      dgsel_zfpar = .false.    ! honour dgsel parameters

      navmode_zfpar = 0        ! navigation mode (0=auto,1=old,2=new)
      
      qpmax_trip_zfpar = 1.    ! maximal q/p for triplet

      down_mode_zfpar = .false.! mode of downstream propagation

      qmin_down_zfpar = 15.    ! minimal quality for downstream propagation

      sline_mode_zfpar = .false. ! straight line fit mode

      slt_mode_zfpar = 0  ! mode of slt track seeding (0 no,1 e,2 mu,3 e+mu)

      slt_magn_zfpar = .false.  ! mode of slt seeded magnet tracking

      tc_mode_zfpar = .true.    ! tc tracking with slt and downstream

      slt_clone_zfpar = .false. ! slt clone are tested with normal ranger

      end

