*-- Author :    Rainer Mankel   02/06/96
*-- changed:    A.Spiridonov    19/03/97
*   nhlmx=150                                        29.09.00  A. Spiridonov
*   exclude flag #NEWNAV                             05.11.00  A. Spiridonov

      subroutine tfpropmn(ift1,direction,istat)

*     **** 3D track-follow all alive seeds in /zf/ (may be in magnet)
      implicit none
#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "rang/zdomain.fi"
#include "rang/zplx.fi"
#include "arte/Arte.fi"
      integer nmax
      parameter (nmax=30)
      integer target_vec(nmax),n_target,tumchit,domlay,dlnext
      integer ift1,ift,izf,ipl,icycle,method,ncan,ii,
     +        zone,iplnext,imust,izfnew,nhl,nhlmx,ihl,dom
      integer mcout,nalive,nmature
      real fracout
      real x_pred,y_pred,dx_window,dy_window,dz,diff_x,window_size
      parameter (nhlmx=150)
      integer hl(nhlmx),nca_now,to_be_grown,direction,istat
      logical continued

      integer dlold, precold, dompointer, rgdomnb, rgdldom
      real xmin,xmax,ymin,ymax,zdom
      real rgzlay, rgzdom

#include "rang/descend.fi"
       
      logical electron

#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "rang/sfdef.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "rang/sf.fi"

**      call tfremcft(ift1,mcout,fracout)
**      print *,' tfpropm: propagate ift=',ift1,
**     +     ' mtra=',mcout

      dlold = 0
      precold = 0

*     **** loop over growth cycles
      istat = 0

      do ii=ift1,ncamx
        descend(ii)=0
      end do

      do 10 icycle=1,99

*      **** loop over present number of track candidates
       nca_now = nca_ft
       begin_ft = nca_ft + 1
       to_be_grown = 0
       do 20 ift=ift1,nca_now

        if (.not.alive_ft(ift)) go to 20
        if (mature_ft(ift))     go to 20
  
        if(descend(ift).ne.0) then     
          ift_descend = descend(ift)
        else
          ift_descend = ift
        end if

        to_be_grown = to_be_grown + 1

        if (diag_level.ge.5) then
         print *,' <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< '
         print *,' << track candidate ', ift, '                    <<'
         print *,' <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< '
        endif

*       **** loop over planes in zone

        izf = last_ft(ift)
        ipl = plane_zf(izf)
        domlay = domlay_zf(izf)
        zone = fault_zf(izf) + 1
        ncan = 0
        continued = .false.
        method = 1  ! 3D    tracking

        if (diag_level.ge.6) then
         print *,' tfpropm: call tfdzone for domlay=', domlay,
     +           '  zone=', zone
        endif

        n_target = 0    ! important
**        print *,' tfpropm: call rgzone direction=',direction,
**     +       ' zone=',zone
        call rgzone(domlay,method-1,zone,direction,2,3,1,nmax,
     +       target_vec,n_target)
**        print *,' tfpropm: rgzone returns ntarget=',n_target,
**     +       ' <-------------------'

        if (diag_level.ge.5) then
         print *,' zone=', zone
         print '(6((a),i5))',
     +     'tfpropm: for ipl=',ipl,' dl=',domlay,' meth=',method,
     +     ' zone=',zone,
     +     ' nmax=',nmax,' we get n_target=', n_target
        endif

        do dom=1,maxdom_dm      ! reset prediction buffer
           filled_db(dom) = .false.
        enddo

        do 30 ii=1,n_target
         dlnext = target_vec(ii)
         if (diag_level.ge.5) print *,' tfpropm: next target=', dlnext
*        **** check if plane is within scope

*        **** check if window is intersected

         dz = rgzlay(dlnext) -  z_zf(izf)
         dompointer = rgdldom( dlnext)
         dom = rgdomnb( dompointer )
         zdom = rgzdom( dompointer )
**         print *,' tfpropm: next target in domnb=',dom,' z=',zdom
**         if (.not.filled_db(dom)) call tfdbfill(dom,izf,istat)

**       check electron identification
         
***         electron = electron_id(ift_descend)   

         electron = .false.
     
         if (.not.filled_db(dom)) call tftrandn(izf,dom,zdom,
     +        electron,istat)

         if (istat.le.-1) go to 30 ! skip target
         x_pred = x_db(1,dom)
         y_pred = x_db(2,dom)
         dx_window = 5.
         dy_window = 20.0

         call rgdlwbord(dlnext,xmin,xmax,ymin,ymax)
         if (x_pred.lt.(xmin-dx_window).or.
     +        x_pred.gt.(xmax+dx_window)) go to 30
         if (y_pred.lt.(ymin-dy_window).or.
     +        y_pred.gt.(ymax+dy_window)) go to 30

*        **** can/must plane found
         ncan = ncan + 1

*        **** loop over hits

         if (dlnext.ne.dlold.or.ift_preced(ift).ne.precold) then
            nhl = 0
**            print *,' tfpropm: call rghlcr...'
            call rghlcr(dlnext,4,dble(z_zf(izf)),
     +           xx_zf(1,izf),xx_zf(2,izf),xx_zf(3,izf),xx_zf(4,izf),
     +           nhlmx,hl,nhl)
**            print *,' .... nhl=',nhl
         endif
*
         if (diag_level.ge.6) print *,' tfpropm: hitlist nhl= ', nhl
         do 40 ihl=1,nhl
          if (diag_level.ge.5) then
           print *,' tfpropm: hitlist ihl=', ihl, ' hit=', hl(ihl),
     +          ' imc=', tumchit(hl(ihl))
          endif
          iplnext = ihitb_gede(hl(ihl))

          diff_x = fhitb_x(hl(ihl))
     +         - (  cstot_plx(iplnext)
     +              * (x_db(1,dom)
     +                 + x_db(3,dom) * (fhitb_z(hl(ihl)) - zdom))
     +            - sntot_plx(iplnext)
     +              * (x_db(2,dom)
     +                 + x_db(4,dom) * (fhitb_z(hl(ihl)) - zdom)))
          window_size = amax1(3.*sngl(dsqrt(cx_db(1,1,dom))),2.)

          if (diag_level.ge.6) then
             print *,' tfpropm: diff_x=',diff_x,
     +            ' window_size=',window_size
          endif

          izfnew = 0
          if (abs(diff_x).lt.window_size) then

             istat = 0

             call tffilmn(hl(ihl),dlnext,iplnext,ift,izf,izfnew,istat)

             if (istat.le.-100) go to 999
             if (istat.le.-1) go to 40
             if (izfnew.gt.0) continued = .true.
          endif

#ifdef TFPROPHIST
          if (cx_db(1,1,dom).ge.0.) then
             if (izfnew.gt.0) call hfill(6211,diff_x,0.,1.)
             call hfill(6212,diff_x,0.,1.)
             call hfill(6221,sngl(dsqrt(cx_db(1,1,dom))),0.,1.)
          endif
#endif

 40      continue  ! hits in hitlist
 30     continue  ! planes in zone

*       **** allow fault on old candidate
        if (fault_zf(izf).lt.maxflt_mag_zfpar) then
         fault_zf(izf) = fault_zf(izf) + 1
         nfault_ft(ift) = nfault_ft(ift) + 1
        else
*        **** kill or freeze old candidate
         if (whit_zf(izf).lt.whitmin_mag_zfpar) then
          alive_ft(ift) = .false.
         else
          mature_ft(ift) = .true.
          stat_ft(ift) = 4
         endif
        endif
        if (diag_level.ge.5) call tfl()

 20    continue

*       print * ,'                                      call tfeed'

       call tfweedM()
       if (diag_level.ge.4) then
        print *,' **********************************************'
        print *,' *                                            *'
        print *,' *                                            *'
        print *,' *           E  N  D     O  F                 *'
        print *,' *                                            *'
        print *,' *           G  R  O  W  T  H                 *'
        print *,' *                                            *'
        print *,' *            C  Y  C  L  E                   *'
        print *,' *                                            *'
        print *,' *                                            *'
        print *,' **********************************************'
        call tfl()
        if (l_diag) call tfwait()
       endif

       if (to_be_grown.le.0) go to 11

 10   continue

      print *,' () tfpropm: loop ends ii=99'

 11   if (diag_level.ge.4) then
       call tfl()
       print *,' **** end growing of seed **** '
      endif

      nalive = 0
      nmature = 0
      do ii=begin_ft,nca_ft
         if (alive_ft(ii)) nalive = nalive + 1
         if (mature_ft(ii)) nmature = nmature + 1
      enddo

**      print *,' ... ended, nalive/nmature=',nalive,nmature,
**     +     whitmin_mag_zfpar

      if (l_diag) call tfwait()

 999  end

