*-- Author :    A. Spiridonov   10/07/98
*-- canged :    A. Spiridonov   15/07/00
*   call of tftcpros.F                               10.11.00  A. Spiridonov
*
      subroutine tftcres

*
*     track reconstruction in TC chambers by means
*     of propagation of track segments from PC 
*     for SLT seeded only (clone of tftcren)

      implicit none

#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "rang/zfpar_tc.fi"
#include "rang/zf.fi"
#include "rang/ztripl.fi"
#include "rang/zcut.fi"
#include "pris/zpstat.fi"
#include "arte/ArteFlag.fi"
#include "arte/Arte.fi"
#include "auto/MIMP.fi"
#include "auto/RSEG.fi"
#include "arte/RSEG_cmp.fi"
#include "rang/descend.fi"

#include "rang/FIXtrit.hh"

*      integer maxlep
*      parameter (maxlep=10)

      integer ift,iiseg,ift1,ift2,nca_x,direction,
     +      begin_store,istat,nca_prep

      logical init

      save init
      data init /.false./

      integer muon1,muon2,pion1,pion2
      integer nh,nh_PC,imimp,jaux,imc,nhmimp,imcass,NRSEG_rec
      real fracmc
      integer NRSEG_stor

      equivalence ( pstat_gold(1,1),muon1 )
      equivalence ( pstat_gold(2,1),muon2 )
      equivalence ( pstat_gold(3,1),pion1 )
      equivalence ( pstat_gold(4,1),pion2 )

#include "arte/Arte.ff"
#include "auto/MIMP.ff"
#include "auto/RSEG.ff"

******************************************************************
*
*     Organization of storage:
*
*           1                  |
*           .                  | x candidates
*           .                  |
*         nca_x                |
*           .                   |
*           .                   | y candidates, 3d candidates
*         nca_y                 |
*           .                    |
*           .                    | magnet seeds
*         nca_prep               |
*           .                     |
*           .                     | magnet candidates
*           .                     |
*
******************************************************************

      l_diag = .false.
      diag_level = 0

      call rginit()
      if (.not.l_rinit) call tfrinit() ! restricted init

      l_term = .false.
      lremzc = .false.

*     **** do the work

*      call tftcms         ! study mult.scat. between PC and TC

      if(jrseg.le.0) go to 999
      if(NRSEG().lt.1) go to 999

      NRSEG_rec = NRSEG()

**      print '("tftcres.F : === NRSEG_rec ",i5 )',NRSEG_rec

      do iiseg = 1,NRSEG_rec
         seg_PC_TC(iiseg) = 0      
         seg_TC_PC(iiseg) = 0 
      end do

      do 10 iiseg=1,NRSEG_rec     ! loop over reconstructed segments
         
         if (irseg_fit(iiseg).ne.0) go to 10 ! select charged track 
  
         if (prseg_rend(iiseg).gt.0) go to 10 ! already continued 

*                                              not slt seeded
         if(IAND(irseg_cmp(iiseg),rsegc_slt).ne.rsegc_slt) go to 10

         if( (IAND(irseg_cmp(iiseg),rsegc_patt).ne.rsegc_patt.and.
     +        IAND(irseg_cmp(iiseg),rsegc_magt).ne.rsegc_magt).or. 
     +        (frseg_ze(iiseg) - frseg_zf(iiseg)).lt.30..or.
     +        IAND(irseg_cmp(iiseg),rsegc_bitsign).eq.rsegc_bitsign)
     +        go to 10          !  reject segment

**        print '(" tftcren.F : segment to be continued ",i4)',iiseg

#ifdef TC_TEST
*           define inc,mimp

         nh_PC = 0
         imimp = 0
         jaux = prseg_hitb(iiseg)
 27      if(jaux.eq.0) go to 30 
         nh = mrseg_hitb(jaux)
         if(nh.gt.0) nh_PC = nh
         jaux = xrseg_hitb(jaux)
         go to 27 
 30      continue

         if(nh_PC.gt.0) then
            call tuhmimp(nh_PC,imc,imimp,nhmimp)
         end if
         
*         call tfremcse(iiseg,imcass,fracmc)

**         print '("tftcre : ++++ is,nh,imc,nhm,iass,f ",5i4,x,f7.2)'
**     +          ,iiseg,nh_PC,imc,nhmimp,imcass,fracmc

***         if(imcass.ne.muon1.and.imcass.ne.muon2) go to 10!select golden mu+-
#endif

         call tfclr()           ! clear p.r. buffer
         begin_ft = 1

         call tftcsen(iiseg,ift1,ift2,istat) ! seed

*         print '("tftcre : ---- muon seg=",i4," istat=",i2)',iiseg,istat
*         print '("tftcre : ---- muon seg=",i4," mcmu,fr= ",3i4,x,f8.3)'
*     +         ,iiseg,imcass,muon1,muon2,fracmc

         if(istat.lt.0) then
            print *,'tftcre: ==== tftcse for seg  ift1,ift2,istat=',
     +           iiseg,ift1,ift2,istat
         end if

         direction = +1

         nca_prep = ift2        ! store new endpointer

         l_2dx = .false.
         l_2dy = .false.
         l_mag = .true.
         begin_ft = nca_prep + 1
         istat = 0

         call tftcpros(ift1,+1,istat)

*         print *,' tftcre: tftcpro returns istat=',istat
         if (istat.ge.0) then
         elseif (istat.le.-100) then
            go to 999           ! no further propagation
         elseif (istat.le.-1) then
            go to 10            ! terminate branch
         endif

         if (diag_level.ge.2) then
            call tfl()
            print *,' after tftcpro,before tfbest'
            call tfwait()
         endif
         begin_ft = nca_prep + 1
         call tfbest()
         if (diag_level.ge.3) then
            call tfl()
            print *,' after tfbest'
            call tfwait()
         endif

*        **** store loop
 9       continue

         begin_store = nca_prep + 1

         do 40 ift=begin_store,nca_ft
            if (.not.alive_ft(ift)) go to 40

**               print *,' ===== tftcre: ift=',ift,
**     +              ' quality=',quality_ft(ift),
**     +              ' cut=',quality_TC_min,
**     +              ' nhit=',nhit_ft(ift)
**               print *,' warning: quality cut removed'

            if (quality_ft(ift).lt.quality_TC_min) go to 40

            NRSEG_stor = NRSEG()
            call tfstseg(ift)
            if(NRSEG().gt.NRSEG_stor) then

#ifdef TC_TEST
               print '("tftcre : set relation RBEG-REND p,t,xpt",2i5
     +              ,2f8.3 )'
     +              ,iiseg,NRSEG(),frseg_xe(iiseg)
     +              ,frseg_xf(NRSEG())
#endif
*     ****  set RBEG <----> REND relation for TC-segments
               call mmbrel(jrsrs,iiseg,NRSEG()) ! set relation
               if (l_diag) call tfwait()
               go to 10
            end if
 40      continue
 10   continue                  !  end of loop on segments

 999  end
