
// ********************************************************************
//
// Routine:      rc99Ainit
//
// Author:       T.Oest/D.Samtleben
//
// Description:  reconstruction initialization
//
// Changes:
// 04 Aug 2000 (AG) added ARTE_mark() 
//
// ********************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>

// ARTE includes
#include "reco/rc99Areco.hh"
#include "marple/marple.hh"
#include "itrarte/ITR_arte.h"
#include "farm/farm.hh"

// prototypes
extern int acFlagReadITR ;
extern "C" void tfinit_();
//void unpackgede();

//*****************************************************************
// function
//*****************************************************************

void
rc99Ainit()
{
  ARTE_mark( "rc99Ainit 0", 0 );

  //==================================================================
  // initilisation of stand alone reconstruction software
  //
  //   1. VDS
  //   2. ECAL
  //   3. MUON
  //   4. ranger 
  //   5. MARPLE
  //==================================================================
  
  ARTE_mark( "rc99AiVDS", 0 );
  rc99AiVDS();
  
  if (acFlagReadITR == 1){
    ARTE_mark( "ItrInit", 0 );
    ItrInit();
  }
  
  ARTE_mark( "rc99AiECAL", 0 );
  rc99AiECAL();
  
  ARTE_mark( "tfinit_", 0 );
  tfinit_();
  
  ARTE_mark( "marpleinit_", 0 );
  marpleinit_();

  ARTE_mark( "rc99Ainit 0", 0 );
}
