
// *****************************************************************************
//
// Routine:      rc99Avertex
// Author:       T.Oest
//
// Description:  main vertex reconstruction
//
// Modification:
// 16 Sep 1999 (TO) vertex reconstruction only together with matching
// 01 Dec 1999 (TO) also called if new tracks are selected
//                  K0S included, steering included
// 26 May 2000 (DS) primary vertex search done now by LOVER         
// 31 Oct 2000 (AG) prepared for grover                             
// 02 Nov 2000 (AG) enabled grover
//
// *****************************************************************************

// standard includes
#include <algo.h>

// ARTE includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "reco/rcflags.hh"
#include "grover/grover.hh"

// prototypes
extern "C" void v0k0s_();

//
// function  
//
void
rc99Avertex()
{
  ARTE_mark( "rc99Avertex 0", 0 );
  
  //
  // vertexing
  //
  if( rcMainVertex == 1 ){
    ARTE_mark( "GroverEvent", 0 );
    GroverEvent();
  }
  
  //
  // K0s vertexing
  //
  if( rcK0SVertex == 1 ){
    ARTE_mark( "v0k0s", 0 );
    v0k0s_(); 
  }
  
  ARTE_mark( "rc99Avertex 1", 0 );
}
