// ********************************************************************
//
//  Routine:      rcMoment
//  Author:       D.Samtleben
//
//  Description:  calculate momentum for OTR segments
//
//  Modification:
//
// ********************************************************************


#include <iostream.h>
#include <stdlib.h>
#include "arte/arte.hh"
#include "reco/rc99Areco.hh"
#include "reco/rcflags.hh"
#include <arte/RSEG_cmp.hh>
#include <marple/marple.hh>

int rc99removeBadRseg();


//*****************************************************************
// function  
//*****************************************************************

int rcMoment() {

  int flag = 0;

  rc99removeBadRseg();

//==================================================================
// determine momentum
//==================================================================

  if (rcMomentumdet == 1) {

  for( ArteTable<RSEG>::iterator irseg = ArteTable<RSEG>::begin();
       irseg != ArteTable<RSEG>::end(); ++irseg )
    {
      if ( (*irseg)->fit != 0 ) continue;
      if( ((*irseg)->cmp & Rsegc::bitsign) != 0 ) continue;
      if(  ((*irseg)->cmp & Rsegc::patt) && !((*irseg)->cmp & Rsegc::magt))
        {
          RcSegPoint  otr( (*irseg), 0 ); //first point
          // initial value from kick :
          float overMomentum = ( otr.tx()*otr.z() - otr.x() ) / 288;
          if( fabs(overMomentum) <  2 ) // Pt > 0.5 GeV
            {
              otr.setpe( overMomentum);
              int iErr;
              otr.estimatePEfromTAR( 5, iErr);
              (*irseg)->pf = otr.pe(); 
            }else{
              (*irseg)->pf = overMomentum;
            }
        }
    }
  };

//==================================================================
  return flag;

};

