// ********************************************************************
//
//  Routine:      rcRTRAmatchMTRA
//  Author:       T.Oest
//
//  Description:  match RTRA with MTRA tracks
//
//  Modification:
//
// ********************************************************************

#include <iostream>
#include <set>
#include <math.h>

#include <arte/arte.hh>

//*****************************************************************
// function
//*****************************************************************

int rcRTRAmatchMTRA(){

  if (ArteTable<MTRA>::size() == 0 )  return -1;

//==================================================================
// 1. loop over RTRA 
//==================================================================

  for( ArteTable<RTRA>::iterator rtra = ArteTable<RTRA>::begin();
       rtra != ArteTable<RTRA>::end(); ++rtra ) {

    if (rtra->fit == 0 || rtra->fit == 11 ){


//==================================================================
// 2. search for best MTRA match
//==================================================================

  ArtePointer<MTRA> mtralist[20];
  int               mtrahits[20];

  int nMTRA = -1;
  

    for( ArteRelationIterator<HITB> hitb = rtra->hitb.begin();
	 hitb != rtra->hitb.end(); ++hitb ) {

    for( ArteRelationIterator<MIMP> mimp = (*hitb)->mimp.begin();
	 mimp != (*hitb)->mimp.end(); ++mimp ) {
 
      ArtePointer<MTRA> mtra = (*mimp)->mtra;

       int i = 0;
       while ( i <= nMTRA && mtra != mtralist[i]) i++;

       if (i > nMTRA){
	 if (nMTRA <= 18){
           nMTRA++;
           mtrahits[nMTRA] = 0;
           mtralist[nMTRA] = mtra;
         };
       } else {
         ++mtrahits[i];
       };
    };
    };

    if (nMTRA >=0) { 

/*
     int imax    = 0;

     for (int i = 0; i <= nMTRA; i++)
       if (mtrahits[i] >= mtrahits[imax]) imax = i ;

     createRelation( *rtra, mtralist[imax], &RTRA::mtra );
*/

     for (int i = 0; i <= nMTRA; i++)
       if (mtrahits[i] >= 6)
         createRelation( *rtra, mtralist[i], &RTRA::mtra );


    };

  
 };};

//==================================================================
// 1. loop over RSEG 
//==================================================================

  for( ArteTable<RSEG>::iterator rseg = ArteTable<RSEG>::begin();
       rseg != ArteTable<RSEG>::end(); ++rseg ) {

    if (rseg->mtra.begin() == rseg->mtra.end()){


//==================================================================
// 2. search for best MTRA match
//==================================================================

  ArtePointer<MTRA> mtralist[20];
  int               mtrahits[20];

  int nMTRA = -1;
  

    for( ArteRelationIterator<HITB> hitb = rseg->hitb.begin();
	 hitb != rseg->hitb.end(); ++hitb ) {

    for( ArteRelationIterator<MIMP> mimp = (*hitb)->mimp.begin();
	 mimp != (*hitb)->mimp.end(); ++mimp ) {
 
      ArtePointer<MTRA> mtra = (*mimp)->mtra;

       int i = 0;
       while ( i <= nMTRA && mtra != mtralist[i]) i++;

       if (i > nMTRA){
	 if (nMTRA <= 18){
           nMTRA++;
           mtrahits[nMTRA] = 0;
           mtralist[nMTRA] = mtra;
         };
       } else {
         ++mtrahits[i];
       };
    };
    };

    if (nMTRA >=0) { 


     for (int i = 0; i <= nMTRA; i++)
       if (mtrahits[i] >= 6)
         createRelation( *rseg, mtralist[i], &RSEG::mtra );


    };

  
 };};

//==================================================================

return 0;
};
