!----------------------------------------------------------------------
! get tracks from RTRA
! M. Staric, jan-2000
!
!----------------------------------------------------------------------


      SUBROUTINE GET_TRACKS(IER)

      IMPLICIT NONE
      INTEGER IER

#include "riter/RIC_TRA.fi"

#include "arte/Arte.fi"
#include "auto/RTRA.fi"
#include "auto/RPNT.fi"

      INTEGER IROW,INDX,IR,IR0,ITRA,I
      REAL X,Y,Z,Z0,TX,TY,TT,PP
      REAL Z_MIN, Z_MAX
      SAVE Z_MIN, Z_MAX
      DATA Z_MIN /500./, Z_MAX /1001./

#include "arte/Arte.ff"
#include "auto/RTRA.ff"
#include "auto/RPNT.ff"

      NTRA=0
      DO IROW=1,NRTRA()
         IF(IRTRA_FIT(IROW).NE.0) GOTO 1
         IF(IRTRA_HSI(IROW).EQ.0) GOTO 1
         IF(IRTRA_HOU(IROW)+IRTRA_HIN(IROW).EQ.0) GOTO 1
         INDX=PRTRA_RPNT(IROW)
         IR0=0
         Z0=Z_MIN
         DO WHILE(INDX.GT.0)
            IR=MRTRA_RPNT(INDX)
            Z=FRPNT_ZF(IR)
            IF(Z.GT.Z0.AND.Z.LT.Z_MAX) THEN
               Z0=Z
               IR0=IR
            ENDIF
            INDX=XRTRA_RPNT(INDX)
         ENDDO
         IF(IR0.EQ.0) GOTO 1
         NTRA=NTRA+1
         IF(NTRA.GT.MAXTRA) GOTO 1
         T_R(1,NTRA)=FRPNT_XF(IR0)
         T_R(2,NTRA)=FRPNT_YF(IR0)
         T_R(3,NTRA)=FRPNT_ZF(IR0)
         TX=FRPNT_TXF(IR0)
         TY=FRPNT_TYF(IR0)
         CALL GLOBAL_TO_RICH(T_R(1,NTRA),TX,TY)
         DO I=1,3
            T_R(I,NTRA)=T_R(I,NTRA)*10. ! to milimeters
         ENDDO
         TT=SQRT(TX**2+TY**2+1.)
         T_DIR(1,NTRA)=TX/TT
         T_DIR(2,NTRA)=TY/TT
         T_DIR(3,NTRA)=1./TT
         PP=FRPNT_PF(IR0)
         IF(PP.NE.0) THEN
            T_MOM(NTRA)=1/ABS(PP)
         ELSE
            T_MOM(NTRA)=1000.
         ENDIF
         T_SIG(1,NTRA)=SQRT(FRPNT_CVF(6,IR0))
         T_SIG(2,NTRA)=SQRT(FRPNT_CVF(10,IR0))
! correction for track sigma
         CALL CORRECT_T_SIG(T_SIG(1,NTRA))
! end
         T_SMOM(NTRA)=SQRT(ABS(FRPNT_CVF(14,IR0))) ! d(Q/p) !!!
         MC_TIP(NTRA)=0
         RTRA_ROW(NTRA)=IROW
 1       CONTINUE
      ENDDO

      DO ITRA=1,MIN(NTRA,MAXTRA)
         DO I=0,NHYP-1
            THC(I,ITRA)=0.
            STFS(I,ITRA)=0.
            PLKH(I,ITRA)=0
         ENDDO
         STFB(ITRA)=0.
         AX3(ITRA)=0.
         SFOT(ITRA)=0.
         PID(ITRA)=0
         RECO_FLAG(ITRA)=0
      ENDDO
      IER=MAX(0,NTRA-MAXTRA)
      NTRA=MIN(NTRA,MAXTRA)

      RETURN
      END



      SUBROUTINE GLOBAL_TO_RICH(R,TX,TY)

! transformation from global to local (RICH)

      IMPLICIT NONE
      REAL R(3), TX, TY

#include "arte/Arte.fi"
#include "auto/ACGA.fi"
      REAL DX, DY, DZ, DTX, DTY, FZ, ROT(3,3), Z0
      SAVE DX, DY, DZ, DTX, DTY, FZ, ROT, Z0
      LOGICAL START /.TRUE./, GIVEN /.FALSE./
      SAVE START, GIVEN
      INTEGER IR, I, K, II
      REAL X,Y,TXX,TYY,CFI,SFI,DZZ
#include "arte/Arte.ff"
#include "auto/ACGA.ff"

      IF(START) THEN
         START=.FALSE.
         DO IR=1,NACGA()
            IF(IACGA_CMP(IR).EQ.67108864) THEN
               GIVEN=.TRUE.
               DX=FACGA_DX(IR)
               DY=FACGA_DY(IR)
               DZ=FACGA_DZ(IR)
               DTX=FACGA_DTX(IR)
               DTY=FACGA_DTY(IR)
               FZ=FACGA_FZ(IR)
               DO K=1,3
                  DO I=1,3
                     II=I+(K-1)*3
                     ROT(I,K)=FACGA_ROT(II,IR)
                  ENDDO
               ENDDO
               Z0=FACGA_Z(IR)
               GOTO 2
            ENDIF
         ENDDO
 2       CONTINUE
      ENDIF
      IF(.NOT.GIVEN) RETURN
      CFI=ROT(1,1)
      SFI=ROT(1,2)

      DZZ=R(3)-Z0
      X=R(1)-DX-DZZ*DTX
      Y=R(2)-DY-DZZ*DTY
      TXX=TX-DTX
      TYY=TY-DTY
      R(1)=( X*CFI+Y*SFI)
      R(2)=(-X*SFI+Y*CFI)
      R(3)=R(3)
      TX= TXX*CFI+TYY*SFI
      TY=-TXX*SFI+TYY*CFI

      RETURN
      END



