*CMZ :          07/11/96  12.55.17  by  T. Oest
*-- Author :    T. Oest   27/09/96

      SUBROUTINE V0STOR(FLAG, IT1, IT2, CH1, PTRK, VTRK, TOPP0,
     +                  TOPP1, TOPP2)
************************************************************************
*
* Description: store vertex in RVER and RTRA bank
*
* Called from:
*
* External references:
*
* Argument in/out description
* FLAG     in     = 100 K0s
*                   110 J/psi
*                   120 B0
* IT1      in     first track in RTRA
* IT2      in     second track in RTRA
* PTRK(7)  in     track parameter (z,x,y,tx,ty,r,m)
* VTRK(7,7)in     covariance matrix for PTRK
* TOPP0    in     TOPP row of vertex particle
* TOPP1    in     TOPP row of first  particle
* TOPP2    in     TOPP row of second particle
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/EV.fi"
#include "auto/CON.fi"

      INTEGER          FLAG, IT1, IT2, TOPP0, TOPP1, TOPP2
      DOUBLE PRECISION CH1
      DOUBLE PRECISION PTRK(7), VTRK(7,7)


#include "arte/Arte.ff"
#include "auto/EV.ff"
#include "auto/CON.ff"

C-----------------------------------------------------------------
C  store vertex 
C-----------------------------------------------------------------
         CALL MMBOOK(JRVER, 1)

         Q(QRVER_ZV_L() )   = SNGL(PTRK(1))
         Q(QRVER_XV_L() )   = SNGL(PTRK(2))
         Q(QRVER_YV_L() )   = SNGL(PTRK(3))

         Q(QRVER_CV_L(1))   = SNGL(VTRK(2,2))
         Q(QRVER_CV_L(2))   = SNGL(VTRK(2,3))
         Q(QRVER_CV_L(3))   = SNGL(VTRK(3,3))
         Q(QRVER_CV_L(4))   = SNGL(VTRK(1,2))
         Q(QRVER_CV_L(5))   = SNGL(VTRK(1,3))
         Q(QRVER_CV_L(6))   = SNGL(VTRK(1,1))

         Q(QRVER_MASS_L())  = SNGL(PTRK(7))
         Q(QRVER_MERR_L())  = SQRT(SNGL(VTRK(7,7)))

         IQ(IQRVER_NT_L())  = 2

C-----------------------------------------------------------------
C  store K0s as RTRA track
C-----------------------------------------------------------------
         CALL MMBOOK(JRTRA, 1)

         Q(QRTRA_ZF_L())   = SNGL(PTRK(1))
         Q(QRTRA_XF_L())   = SNGL(PTRK(2))
         Q(QRTRA_YF_L())   = SNGL(PTRK(3))

         Q(QRTRA_TXF_L())  = SNGL(PTRK(4))
         Q(QRTRA_TYF_L())  = SNGL(PTRK(5))
         Q(QRTRA_PF_L())   = SNGL(PTRK(6))

         Q(QRTRA_CVF_L(1)) = SNGL(VTRK(2,2))
         Q(QRTRA_CVF_L(2)) = SNGL(VTRK(2,3))
         Q(QRTRA_CVF_L(3)) = SNGL(VTRK(3,3))
         Q(QRTRA_CVF_L(4)) = SNGL(VTRK(4,2))
         Q(QRTRA_CVF_L(5)) = SNGL(VTRK(4,3))
         Q(QRTRA_CVF_L(6)) = SNGL(VTRK(4,4))
         Q(QRTRA_CVF_L(7)) = SNGL(VTRK(5,2))
         Q(QRTRA_CVF_L(8)) = SNGL(VTRK(5,3))
         Q(QRTRA_CVF_L(9)) = SNGL(VTRK(5,4))
         Q(QRTRA_CVF_L(10))= SNGL(VTRK(5,5))
         Q(QRTRA_CVF_L(11))= SNGL(VTRK(6,2))
         Q(QRTRA_CVF_L(12))= SNGL(VTRK(6,3))
         Q(QRTRA_CVF_L(13))= SNGL(VTRK(6,4))
         Q(QRTRA_CVF_L(14))= SNGL(VTRK(6,5))
         Q(QRTRA_CVF_L(15))= SNGL(VTRK(6,6))

         IQ(IQRTRA_HSI_L())= 0
         IQ(IQRTRA_HIN_L())= 0
         IQ(IQRTRA_HOU_L())= 0
         IQ(IQRTRA_HRI_L())= 0
         IQ(IQRTRA_HCA_L())= 0
         IQ(IQRTRA_HTR_L())= 0
         IQ(IQRTRA_HMU_L())= 0

         IF (FLAG.EQ.100) THEN
          IQ(IQRTRA_FIT_L())= 3
         ELSE
          IQ(IQRTRA_FIT_L())= 2
         ENDIF

         Q(QRTRA_CHI_L())  = SNGL(CH1)

         Q(QRTRA_LRE_L())    = 0.0
         Q(QRTRA_LRMU_L())   = 0.0
         Q(QRTRA_LRPI_L())   = 0.0
         Q(QRTRA_LRK_L())    = 0.0
         Q(QRTRA_LRP_L())    = 0.0

         Q(QRTRA_LTE_L())    = 0.0
         Q(QRTRA_LTH_L())    = 0.0

         Q(QRTRA_LMMU_L())   = 0.0
         Q(QRTRA_LMH_L())    = 0.0

         Q(QRTRA_LEE_L())    = 0.0
         Q(QRTRA_LEMI_L())   = 0.0
         Q(QRTRA_LEH_L())    = 0.0


C-----------------------------------------------------------------
C  store track information
C-----------------------------------------------------------------
         CALL MMBOOK(JRREL, 1)

         IQ(IQRREL_FLAG_L()) = 1
         IQ(IQRREL_TOPP_L()) = TOPP1

         Q(QRREL_CHI_L())    = 0.5*SNGL(CH1)


         CALL MMBOOK(JRREL, 1)

         IQ(IQRREL_FLAG_L()) = 1
         IQ(IQRREL_TOPP_L()) = TOPP2

         Q(QRREL_CHI_L())    = 0.5*SNGL(CH1)

C-----------------------------------------------------------------
C  track to vertex relations
C-----------------------------------------------------------------
         CALL MMBREL(JRRRT, IT1, NRREL()-1)
         CALL MMBREL(JRRRT, IT2, NRREL()  )

         CALL MMBREL(JRRRV, NRVER(), NRREL()-1)
         CALL MMBREL(JRRRV, NRVER(), NRREL()  )

         CALL MMBREL(JRVRT, NRTRA(), NRVER())

         CALL MMBREL(JRTTO, TOPP0, NRTRA())


************************************************************************
* End of V0STOR
************************************************************************
      END




