*CMZ :          20/05/96  12.58.34  by  Unknown
*-- Author :    T.Lohse
c
c------------------------------------------------------------
c
c       subroutine:   VTDIS(iv,ifail)
c
c       input:    iv       =  vertex index      Int
c
c       output:   ifail   <0 if fail            Int
c
c       action:   get smoothed residuals for tracks on iv
c                 get new state vectors and covariance matrices
c                 with a point removed
c
c------------------------------------------------------------
c
      subroutine VTDIS(iv,ifail)

      implicit none

      integer iv,ifail,flag

      integer n,i,j,k,it,momflg,imax,jmax
      double precision 
     1  Cwork(3,3),pc(5),AGpc(3),Cx(3)
      double precision 
     1  b13,a33,a34,sum,dx(3),dp(5),chi2sr

#include "vt/vtdat.fi"

      ifail = -1
      if (iv.gt.nvtmax)  return
      if ( .not. vtset(iv) ) return

      n = ntr(iv)
      if ( n.lt.1 )      return

      if ( fit(iv).eq.0 ) then
        call VTFIT(iv,0,flag)
        if ( flag.lt.0 )   goto 999
      endif
      if ( smooth(iv) .eq. 0 ) call VTSMO(iv)

      if ( fit(iv) .eq. 2 ) then
        momflg = 1
        imax = 5
        jmax = 3
      else
        momflg = 0
        imax = 4
        jmax = 2
      endif

      b13 = Bk13(iv)

      do  k = 1, n

        it = ktr(iv,k)

        a33 = Ak33(iv,k)
        a34 = Ak34(iv,k)

        do  i = 1, 3
          do  j = i, 3
            CnkINV(i,j,iv,k) = CINV(i,j,iv,n)
     1               - ( CINV(i,j,iv,k) - CINV(i,j,iv,k-1) )
            CnkINV(j,i,iv,k) = CnkINV(i,j,iv,k)
            Cwork(i,j) = CnkINV(i,j,iv,k)
            Cwork(j,i) = Cwork(i,j)
          enddo
        enddo
        flag = 0
        call DSINV(3,Cwork,3,flag)
        if ( flag .eq. -1 )         goto 999
        do  i = 1, 3
          do  j = i, 3
            Cnk(i,j,iv,k) = Cwork(i,j)
            Cnk(j,i,iv,k) = Cwork(i,j)
          enddo
        enddo

c------->   un-filtered state vector

        pc(1) = p(1,it)
        pc(2) = p(2,it)
        pc(3) = p(3,it) - b13*a33
        pc(4) = p(4,it) - b13*a34
        if (momflg.eq.1) pc(5) = p(5,it)

        do  i = 1, 2
          AGpc(i) = 0.
          do  j = 1, imax
            AGpc(i) = AGpc(i) + GB(j,i+2,iv,k)*pc(j)
          enddo
        enddo
        AGpc(3) = 0.
        do  j = 1, imax
          AGpc(3) = AGpc(3) + pc(j) *
     1        ( a33*GB(j,3,iv,k) + a34*GB(j,4,iv,k) )
        enddo

        do  i = 1, 3
          Cx(i) = -AGpc(i)
          do  j = 1, 3
            Cx(i) = Cx(i) + CINV(i,j,iv,n)*xv(j,iv,n)
          enddo
        enddo
        do  i = 1, 3
          xnk(i,iv,k) = 0.
          do  j = 1, 3
            xnk(i,iv,k) = xnk(i,iv,k) + Cnk(i,j,iv,k)*Cx(j)
          enddo
        enddo

c-------> chi**2 of smoothed residuals

        do  i = 1, 3
          dx(i) = xv(i,iv,n) - xnk(i,iv,k)
        enddo
        dp(1) = p(1,it) - qvs(1,iv,k)
        dp(2) = p(2,it) - qvs(2,iv,k)
        dp(3) = p(3,it) - xv(1,iv,n)
     1          - xv(3,iv,n)*a33 - b13*qvs(1,iv,k) - a33*b13
        dp(4) = p(4,it) - xv(2,iv,n)
     1          - xv(3,iv,n)*a34 - b13*qvs(2,iv,k) - a34*b13
        if (momflg.ne.0) dp(5) = p(5,it) - qvs(3,iv,k)

        chi2sr = 0.d0
        do  i = 1, imax
          chi2sr = chi2sr + dp(i)**2*G(i,i,it)
        enddo
        do  i = 1, imax-1
          sum = 0.
          do  j = i+1, imax
            sum = sum + dp(j)*G(i,j,it)
          enddo
          chi2sr = chi2sr + 2.*dp(i)*sum
        enddo
        do  i = 1, 3
          chi2sr = chi2sr + dx(i)**2*CnkINV(i,i,iv,k)
        enddo
        do  i = 1, 2
          sum = 0.
          do  j = i+1, 3
            sum = sum + dx(j)*CnkINV(i,j,iv,k)
          enddo
          chi2sr = chi2sr + 2.*dx(i)*sum
        enddo

        chi2s(iv,k) = chi2sr

      enddo

      dist(iv) = 1
      ifail = 0
      return

  999 continue

      ifail = -1

      return
      end
