*CMZ :          20/05/96  12.58.00  by  Unknown
*-- Author :   T.Lohse
c
c-------------------------------------------------------------
c
c       subroutine:   VTRECB(il1,il2,iKs,itB,flag)
c
c
c       input:    il1 = lepton track no 1           Int
c                 il2 = lepton track no 2           Int
c                 iKs = Ks track no                 Int
c
c       output:   itB = track no of reconstructed B Int
c                 flag (<0 if fail)                 Int
c                 flag=-1  B decay vertex fit failed (give up)
c                 flag=-2  B incompatible with wire  (give up)
c                 flag=-3  vertex recognition had problems
c                 flag=-4  fits in vtx recog. not convergent
c
c       action:   reconstruct primary and secondary vertices
c                 including one primary vertex of a
c                 B meson (itB) decaying into two
c                 leptons (il1,il2) and a Ks (iKs)
c
c-------------------------------------------------------------
c
      subroutine  VTRECB(il1,il2,iKs,itB,flag)

      implicit none

      integer flag, il1, il2, iKs, itB
      integer flag1, flag2, flag3

      flag = 0

      call  VTPSIK(il1,il2,iKs,itB,flag3)
      if (flag3.lt.0) then
        flag = flag3
        goto 999
      endif

      call VTPRIM(itB,flag1)
      call VTSEC( itB,flag2)

      if (flag1.lt.0.or.flag2.lt.0)   flag=-3
      if (flag1.eq.-2.or.flag2.eq.-2) flag=-4

  999 continue

      return
      end
