/************************************************************************
**
** Description: Simple routines for conversion from ASCII ASDid
**              to numbers and back.
**
** Author: A.Lanyov    September 99
** 
************************************************************************/
 
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "OTrAsdId.h"

int asdid2num(const char *asdid,
              unsigned char *SL, unsigned char *lay, unsigned char *sec, unsigned char *asd) {
/***************************************************************************
  Converts ASDid in the form of "+t2-3-01-80"
  to integer numbers SL, lay, sec, asd which are used in OTrDecode package.
 ***************************************************************************/
  unsigned char supernumb;

  supernumb = atoi(asdid+2);
  *lay = atoi(asdid+4);
  *sec = atoi(asdid+6);
  *asd = atoi(asdid+9);

  if      (*(asdid+1)=='m') *SL = supernumb;
  else if (*(asdid+1)=='p') *SL = supernumb + 8;
  else if (*(asdid+1)=='t') *SL = supernumb + 12;
  else {
#ifdef __WAX_DEBUG__
    printf("asdid2num: Illegal asdid = %s !!!\n",asdid);
#endif
    *SL = 90+supernumb;
    return 1;
  }
  if (*asdid=='+') *SL += 16;
  return 0;
}


int num2asdid(const unsigned char SL, const unsigned char lay,
	      const unsigned char sec, const unsigned char asd,
              char *asdid) {
/***************************************************************************
  Converts integer numbers SL, lay, sec, asd
  which are used in OTrDecode package
  to ASDid in the form of "+t2-3-01-80".
 ***************************************************************************/
  char supername[3];

  if      (SL<16) strncpy(supername,"-",1);
  else if (SL<32) strncpy(supername,"+",1);
  else {
    printf("num2asdid: illegal SL=%d !!!\n",SL);
    strncpy(supername," ",1);
  };

  if      (SL%16 <=  8) sprintf(supername+1, "m%1d", SL%16);
  else if (SL%16 <= 12) sprintf(supername+1, "p%1d", SL%16-8);
  else if (SL%16 <= 14) sprintf(supername+1, "t%1d", SL%16-12);
  else {
    printf("num2asdid: illegal SL=%d !!!\n",SL);
    sprintf(supername+1,"?%1d",SL%10);
  };

  sprintf(asdid,"%s-%1d-%2.2d-%2.2d",supername,lay,sec,asd);
  return 0;
}
